part of kitcod_uikit_flutter;

class CheckKitcodUser {
  CheckKitcodUser._();

  static final CheckKitcodUser _instance = CheckKitcodUser._();

  static CheckKitcodUser get instance => _instance;

  Future<String?> createUser(final String firstName,
      final String lastName, final String apiKey) async {
    try {
      final body = {
        "firstName": firstName,
        "lastName": lastName,
      };

      final url = Uri.parse(ApiConfig.usersPath);
      final response = await http.post(
        url,
        headers: {
          "x-api-key": apiKey,
          "content-type": "application/json",
        },
        body: jsonEncode(body),
      );
      if (response.statusCode == 201) {
        return response.body;
      } else {
        throw Exception("Failed to create post");
      }
    }catch (error) {
      rethrow;
    }
  }

}

