part of kitcod_uikit_flutter;

class KitCodUIKit {
  KitCodUIKit._();

  static final KitCodUIKit _instance = KitCodUIKit._();

  static KitCodUIKit get init => _instance;

  Future<void> connect(final String apiKey, final String firstName, final String lastName,
      final String profileUrl,final String userID,final ConnectedHandler handler)
  async {
    final SharedPreferences prefs =  await SharedPreferences.getInstance();
    try {
      final response = await KitcodApi.instance.getAppInfo(apiKey);
      if (response.id!.isNotEmpty) {
        if (userID.isEmpty) {
          //Create user as UserId doesn't exist
          final userResponse = await KitcodApi.instance.createUser(
              firstName, lastName, profileUrl, apiKey);
          if (userResponse.id!.isNotEmpty) {
            await prefs.setString(ApiConfig.kcUserId, userResponse.id!);
            await prefs.setString(ApiConfig.kcAPIKey, apiKey);
            handler.onConnected(userResponse.id!, null);
          } else {
            //User not created
          }
        } else {
          final userResponse = await KitcodApi.instance.getUserProfileAWSDataID(userID);
          if (userResponse.id!.isNotEmpty) {
            await prefs.setString(ApiConfig.kcUserId, userResponse.id!);
            await prefs.setString(ApiConfig.kcAPIKey, apiKey);
            handler.onConnected(userResponse.id!, null);
          }
        }
      } else {
        //API Key has issues
        handler.onConnected("response", null);
      }
    } catch (e) {
      handler.onConnected("", e as Exception);
    }
  }
}

