// ignore_for_file: sort_constructors_first, unnecessary_lambdas, avoid_dynamic_calls

part of kitcod_uikit_flutter;

CommentApi commentApiFromJson(final String str) =>
    CommentApi.fromJson(json.decode(str) as Map<String, dynamic>);

String commentApiToJson(final CommentApi data) => json.encode(data.toJson());

class CommentApi {
  CommentApi({
    this.embeddedComment,
    this.page,
  });

  EmbeddedComment? embeddedComment;
  Page? page;

  factory CommentApi.fromJson(final Map<String, dynamic> json) => CommentApi(
        embeddedComment: json["_embeddedt"] == null
            ? null
            : EmbeddedComment.fromJson(
                json["_embeddedt"] as Map<String, dynamic>),
        page: json["page"] == null
            ? null
            : Page.fromJson(json["page"] as Map<String, dynamic>),
      );

  Map<String, dynamic> toJson() => {
        "_embeddedComment": embeddedComment ?? embeddedComment!.toJson(),
        "page": page ?? page!.toJson(),
      };
}

class EmbeddedComment {
  EmbeddedComment({
    this.commentList,
  });

  List<CommentList>? commentList;

  factory EmbeddedComment.fromJson(final Map<String, dynamic> json) =>
      EmbeddedComment(
        commentList: json["commentList"] == null
            ? null
            : List<CommentList>.from(json["commentList"].map((final x) =>
                    CommentList.fromJson(x as Map<String, dynamic>))
                as Iterable<dynamic>),
      );

  Map<String, dynamic> toJson() => {
        "commentList": commentList ??
            List<dynamic>.from(commentList!.map((final x) => x.toJson())),
      };
}

class CommentList {
  CommentList({
    this.uuid,
    this.createdTs,
    this.updatedTs,
    this.createdBy,
    this.updatedBy,
    this.version,
    this.id,
    this.resourceType,
    this.resourceId,
    this.userId,
    this.communityId,
    this.html,
    this.active,
    this.creator,
    this.interactionSummary,
  });

  String? uuid;
  String? createdTs;
  String? updatedTs;
  String? createdBy;
  String? updatedBy;
  int? version;
  String? id;
  String? resourceType;
  String? resourceId;
  String? userId;
  String? communityId;
  String? html;
  bool? active;
  UserProfile? creator;
  InteractionSummary? interactionSummary;

  factory CommentList.fromJson(final Map<String, dynamic> json) => CommentList(
        uuid: json["uuid"] as String?,
        createdTs: json["createdTS"] as String?,
        updatedTs: json["updatedTS"] as String?,
        createdBy: json["createdBy"] as String?,
        updatedBy: json["updatedBy"] as String?,
        version: json["version"] as int?,
        id: json["id"] as String?,
        resourceType: json["resourceType"] as String?,
        resourceId: json["resourceId"] as String?,
        userId: json["userId"] as String?,
        communityId: json["communityId"] as String?,
        html: json["html"] as String?,
        active: json["active"] as bool?,
        creator: json["creator"] == null
            ? null
            : UserProfile.fromJson(json["creator"] as Map<String, dynamic>),
        interactionSummary: json["interactionSummary"] == null
            ? null
            : InteractionSummary.fromJson(
                json["interactionSummary"] as Map<String, dynamic>),
      );

  Map<String, dynamic> toJson() => {
        "uuid": uuid,
        "createdTS": createdTs,
        "updatedTS": updatedTs,
        "createdBy": createdBy,
        "updatedBy": updatedBy,
        "version": version,
        "id": id,
        "resourceType": resourceType,
        "resourceId": resourceId,
        "userId": userId,
        "communityId": communityId,
        "html": html,
        "active": active,
        "creator": creator ?? creator!.toJson(),
        "interactionSummaryComment":
            interactionSummary ?? interactionSummary!.toJson(),
      };
}

class Page {
  Page({
    this.size,
    this.totalElements,
    this.totalPages,
    this.number,
  });

  int? size;
  int? totalElements;
  int? totalPages;
  int? number;

  factory Page.fromJson(final Map<String, dynamic> json) => Page(
        size: json["size"] as int?,
        totalElements: json["totalElements"] as int?,
        totalPages: json["totalPages"] as int?,
        number: json["number"] as int?,
      );

  Map<String, dynamic> toJson() => {
        "size": size,
        "totalElements": totalElements,
        "totalPages": totalPages,
        "number": number,
      };
}
