// ignore_for_file: constant_identifier_names, unnecessary_lambdas, avoid_dynamic_calls

part of kitcod_uikit_flutter;

Postapi postapiFromJson(final String str) =>
    Postapi.fromJson(json.decode(str) as Map<String, dynamic>);

String postapiToJson(final Postapi data) => json.encode(data.toJson());

class Postapi {
  Postapi({
    this.embedded,
    this.links,
    this.page,
  });

  factory Postapi.fromJson(final Map<String, dynamic> json) => Postapi(
        embedded: json["_embedded"] == null
            ? null
            : Embedded.fromJson(json["_embedded"] as Map<String, dynamic>),
        links: json["_links"] == null
            ? null
            : Links.fromJson(json["_links"] as Map<String, dynamic>),
        page: json["page"] == null
            ? null
            : Page.fromJson(json["page"] as Map<String, dynamic>),
      );

  Embedded? embedded;
  Links? links;
  Page? page;

  Map<String, dynamic> toJson() => {
        "_embedded": embedded ?? embedded!.toJson(),
        "_links": links ?? links!.toJson(),
        "page": page ?? page!.toJson(),
      };
}

class Embedded {
  Embedded({
    this.postList,
  });

  factory Embedded.fromJson(final Map<String, dynamic> json) => Embedded(
        postList: json["postList"] == null ? null : List<PostList>.from(
            // ignore: avoid_dynamic_calls
            json["postList"].map(PostList.fromJson) as Iterable<dynamic>),
      );

  List<PostList>? postList;

  Map<String, dynamic> toJson() => {
        "postList": postList ??
            List<dynamic>.from(postList!.map((final x) => x.toJson())),
      };
}

class PostList {
  PostList({
    this.uuid,
    this.createdTs,
    this.updatedTs,
    this.createdBy,
    this.updatedBy,
    this.version,
    this.id,
    this.appId,
    this.title,
    this.contentHtml,
    this.contentMarkdown,
    this.postType,
    this.communityId,
    this.publishedTs,
    this.interactionSummary,
    this.communityContentVisibility,
    this.community,
    this.media,
    this.creator,
    this.businessCommunity,
    this.active,
    this.poll,
    this.edited,
  });

  factory PostList.fromJson(final Map<String, dynamic> json) => PostList(
        uuid: json["uuid"] as String?,
        createdTs: json["createdTS"] as String?,
        updatedTs: json["updatedTS"] as String?,
        createdBy: json["createdBy"] as String?,
        updatedBy: json["updatedBy"] as String?,
        version: json["version"] as int? ?? 0,
        id: json["id"] as String?,
        appId: json["appId"] as String?,
        title: json["title"] as String?,
        contentHtml:
            json["contentHTML"] == null ? null : json["contentHTML"] as String?,
        contentMarkdown: json["contentMarkdown"] == null
            ? null
            : json["contentMarkdown"] as String?,
        postType: typeValues.map[json["postType"]],
        communityId: json["communityId"] as String?,
        publishedTs: json["publishedTS"] as String?,
        interactionSummary: json["interactionSummary"] == null
            ? null
            : InteractionSummary.fromJson(
                json["interactionSummary"] as Map<String, dynamic>),
        communityContentVisibility: communityContentVisibilityValues
            .map[json["communityContentVisibility"]],
        community: json["community"] == null
            ? null
            : CommunitiesList.fromJson(json["community"] as Map<String, dynamic>),
        media: json["media"] == null
            ? null
            : Media.fromJson(json["media"] as Map<String, dynamic>),
        creator: json["creator"] == null
            ? null
            : UserProfile.fromJson(json["creator"] as Map<String, dynamic>),
        businessCommunity: json["businessCommunity"] as bool,
        active: json["active"] as bool,
        poll: json["poll"] == null
            ? null
            : Poll.fromJson(json["poll"] as Map<String, dynamic>),
        edited: json["edited"] == null ? null : json["edited"] as bool,
      );
  String? uuid;
  String? createdTs;
  String? updatedTs;
  String? createdBy;
  String? updatedBy;
  int? version;
  String? id;
  String? appId;
  String? title;
  String? contentHtml;
  String? contentMarkdown;
  PostType? postType;
  String? communityId;
  String? publishedTs;
  InteractionSummary? interactionSummary;
  CommunityContentVisibility? communityContentVisibility;
  CommunitiesList? community;
  Media? media;
  UserProfile? creator;
  bool? businessCommunity;
  bool? active;
  Poll? poll;
  bool? edited;

  Map<String, dynamic> toJson() => {
        "uuid": uuid,
        "createdTS": createdTs,
        "updatedTS": updatedTs,
        "createdBy": createdBy,
        "updatedBy": updatedBy,
        "version": version,
        "id": id,
        "appId": appId,
        "title": title,
        "contentHTML": contentHtml,
        "contentMarkdown": contentMarkdown,
        "postType": typeValues.reverse[postType],
        "communityId": communityId,
        "publishedTS": publishedTs,
        "interactionSummary":
            interactionSummary ==null? null : interactionSummary!.toJson(),
        "communityContentVisibility": communityContentVisibilityValues
            .reverse[communityContentVisibility],
        "community": community ==null?null: community!.toJson(),
        "media": media ?? media!.toJson(),
        "creator": creator ?? creator!.toJson(),
        "businessCommunity": businessCommunity,
        "active": active,
        "poll": poll ==null?null: poll!.toJson(),
        "edited": edited ?? edited,
      };
}

enum CommunityContentVisibility { private, public }

final communityContentVisibilityValues = EnumValues({
  "PRIVATE": CommunityContentVisibility.private,
  "PUBLIC": CommunityContentVisibility.public
});

class InteractionSummary {
  InteractionSummary({
    this.interactionCounts,
    this.userInteractions,
  });

  factory InteractionSummary.fromJson(final Map<String, dynamic> json) =>
      InteractionSummary(
        interactionCounts: json["interactionCounts"] == null
            ? null
            : Map.from(json["interactionCounts"] as Map<String, dynamic>).map(
                (final k, final v) =>
                    MapEntry<String, int>(k as String, v as int)),
        userInteractions: json["userInteractions"] == null
            ? null
            // ignore: avoid_dynamic_calls
            : List<UserInteraction>.from(json["userInteractions"].map(
                    (final x) =>
                        UserInteraction.fromJson(x as Map<String, dynamic>))
                as Iterable<dynamic>),
      );

  Map<String, int>? interactionCounts;
  List<UserInteraction>? userInteractions;

  Map<String, dynamic> toJson() => {
        "interactionCounts": Map.from(interactionCounts!).map(
            (final k, final v) => MapEntry<String, dynamic>(k as String, v)),
        "userInteractions": userInteractions == null
            ? null
            : List<dynamic>.from(
                userInteractions!.map((final x) => x.toJson())),
      };
}

class UserInteraction {
  UserInteraction({
    this.uuid,
    this.createdTs,
    this.updatedTs,
    this.version,
    this.id,
    this.interactionType,
    this.resourceType,
    this.resourceId,
    this.resourceSubType,
    this.userId,
    this.count,
    this.active,
  });

  factory UserInteraction.fromJson(final Map<String, dynamic> json) =>
      UserInteraction(
        uuid: json["uuid"] as String?,
        createdTs: json["createdTS"] as String?,
        updatedTs: json["updatedTS"] as String?,
        version: json["version"] as int?,
        id: json["id"] as String?,
        interactionType: json["interactionType"] as String?,
        resourceType: json["resourceType"] == null
            ? null
            : resourceTypeValues.map[json["resourceType"]]!,
        resourceId: json["resourceId"] as String?,
        resourceSubType: json["resourceSubType"] == null
            ? null
            : typeValues.map[json["resourceSubType"]],
        userId: json["userId"] as String?,
        count: json["count"] as int?,
        active: json["active"] as bool?,
      );

  String? uuid;
  String? createdTs;
  String? updatedTs;
  int? version;
  String? id;
  String? interactionType;
  ResourceType? resourceType;
  String? resourceId;
  PostType? resourceSubType;
  String? userId;
  int? count;
  bool? active;

  Map<String, dynamic> toJson() => {
        "uuid": uuid,
        "createdTS": createdTs,
        "updatedTS": updatedTs,
        "version": version,
        "id": id,
        "interactionType": interactionType,
        "resourceType": resourceTypeValues.reverse[resourceType],
        "resourceId": resourceId,
        "resourceSubType": typeValues.reverse[resourceSubType],
        "userId": userId,
        "count": count,
        "active": active,
      };
}

final typeValues =
    EnumValues({"ANNOUNCEMENT": PostType.announcement, "POLL": PostType.poll, "REGULAR": PostType.announcement});

enum ResourceType { POST }

final resourceTypeValues = EnumValues({"POST": ResourceType.POST});

class Media {
  Media({
    this.docs,
    this.auds,
    this.imgs,
  });

  factory Media.fromJson(final Map<String, dynamic> json) => Media(
        docs: json["docs"] == null
            ? null
            // ignore: avoid_dynamic_calls
            : List<Aud>.from(json["docs"]
                    .map((final x) => Aud.fromJson(x as Map<String, dynamic>))
                as Iterable<dynamic>),
        auds: json["auds"] == null
            ? null
            // ignore: avoid_dynamic_calls
            : List<Aud>.from(json["auds"]
                    .map((final x) => Aud.fromJson(x as Map<String, dynamic>))
                as Iterable<dynamic>),
        imgs: json["imgs"] == null
            ? null
            // ignore: avoid_dynamic_calls
            : List<Aud>.from(json["imgs"]
                    .map((final x) => Aud.fromJson(x as Map<String, dynamic>))
                as Iterable<dynamic>),
      );

  List<Aud>? docs;
  List<Aud>? auds;
  List<Aud>? imgs;

  Map<String, dynamic> toJson() => {
        "docs": docs == null
            ? null
            : List<dynamic>.from(docs!.map((final x) => x.toJson())),
        "auds": auds == null
            ? null
            : List<dynamic>.from(auds!.map((final x) => x.toJson())),
        "imgs": imgs == null
            ? null
            : List<dynamic>.from(imgs!.map((final x) => x.toJson())),
      };
}

class Aud {
  Aud({
    this.uuid,
    this.id,
    this.resourceType,
    this.resourceId,
    this.type,
    this.mediaUrl,
    this.contentType,
    this.active,
    this.displayRank,
    this.resizedMediaList,
  });

  factory Aud.fromJson(final Map<String, dynamic> json) => Aud(
        uuid: json["uuid"] as String?,
        id: json["id"] as String?,
        resourceType: json["resourceType"] == null
            ? null
            : resourceTypeValues.map[json["resourceType"]],
        resourceId: json["resourceId"] as String?,
        type: json["type"] == null ? null : audTypeValues.map[json["type"]],
        mediaUrl: json["mediaUrl"] as String?,
        contentType: json["contentType"] == null
            ? null
            : contentTypeValues.map[json["contentType"]],
        active: json["active"] as bool?,
        displayRank:
            json["displayRank"] == null ? null : json["displayRank"] as int?,
        resizedMediaList: json["resizedMediaList"] == null
            ? null
            // ignore: avoid_dynamic_calls
            : List<ResizedMediaList>.from(json["resizedMediaList"].map(
                    (final x) =>
                        ResizedMediaList.fromJson(x as Map<String, dynamic>))
                as Iterable<dynamic>),
      );

  String? uuid;
  String? id;
  ResourceType? resourceType;
  String? resourceId;
  AudType? type;
  String? mediaUrl;
  ContentType? contentType;
  bool? active;
  int? displayRank;
  List<ResizedMediaList>? resizedMediaList;

  Map<String, dynamic> toJson() => {
        "uuid": uuid,
        "id": id,
        "resourceType":
            resourceType ?? resourceTypeValues.reverse[resourceType],
        "resourceId": resourceId,
        "type": type ?? audTypeValues.reverse[type],
        "mediaUrl": mediaUrl,
        "contentType": contentType ?? contentTypeValues.reverse[contentType],
        "active": active,
        "displayRank": displayRank,
        "resizedMediaList": resizedMediaList ??
            List<dynamic>.from(resizedMediaList!.map((final x) => x.toJson())),
      };
}

enum ContentType { MP3, PDF, JPG }

final contentTypeValues = EnumValues(
    {"jpg": ContentType.JPG, "mp3": ContentType.MP3, "pdf": ContentType.PDF});

class ResizedMediaList {
  ResizedMediaList({
    this.type,
    this.mediaUrl,
  });

  factory ResizedMediaList.fromJson(final Map<String, dynamic> json) =>
      ResizedMediaList(
        type: json["type"] == null
            ? null
            : resizedMediaListTypeValues.map[json["type"]],
        mediaUrl: json["mediaUrl"] as String?,
      );

  ResizedMediaListType? type;
  String? mediaUrl;

  Map<String, dynamic> toJson() => {
        "type": resizedMediaListTypeValues.reverse[type],
        "mediaUrl": mediaUrl,
      };
}

enum ResizedMediaListType { THUMBNAIL, RESIZED }

final resizedMediaListTypeValues = EnumValues({
  "resized": ResizedMediaListType.RESIZED,
  "thumbnail": ResizedMediaListType.THUMBNAIL
});

enum AudType { COMMUNITY_AUDIO, COMMUNITY_DOCUMENT, COMMUNITY_PIC }

final audTypeValues = EnumValues({
  "CommunityAudio": AudType.COMMUNITY_AUDIO,
  "CommunityDocument": AudType.COMMUNITY_DOCUMENT,
  "CommunityPic": AudType.COMMUNITY_PIC
});

class Poll {
  Poll({
    this.options,
    this.endDateTime,
    this.timeZoneId,
    this.timeZoneOffset,
  });

  factory Poll.fromJson(final Map<String, dynamic> json) => Poll(
        options: json["options"] == null
            ? null
            : List<Option>.from(json["options"].map(
                    (final x) => Option.fromJson(x as Map<String, dynamic>))
                as Iterable<dynamic>),
        endDateTime: json["endDateTime"] as String?,
        timeZoneId: json["timeZoneId"] as String?,
        timeZoneOffset: json["timeZoneOffset"] as String?,
      );

  List<Option>? options;
  String? endDateTime;
  String? timeZoneId;
  String? timeZoneOffset;

  Map<String, dynamic> toJson() => {
        "options": options ??
            List<dynamic>.from(options!.map((final x) => x.toJson())),
        "endDateTime": endDateTime,
        "timeZoneId": timeZoneId,
        "timeZoneOffset": timeZoneOffset,
      };
}

class Option {
  Option({
    this.type,
    this.text,
  });

  factory Option.fromJson(final Map<String, dynamic> json) => Option(
        type: json["type"] as String?,
        text: json["text"] as String?,
      );

  String? type;
  String? text;

  Map<String, dynamic> toJson() => {
        "type": type,
        "text": text,
      };
}

class Links {
  Links({
    this.next,
    this.last,
  });

  factory Links.fromJson(final Map<String, dynamic> json) => Links(
        next: json["next"] == null
            ? null
            : Last.fromJson(json["next"] as Map<String, dynamic>),
        last: json["last"] == null
            ? null
            : Last.fromJson(json["last"] as Map<String, dynamic>),
      );

  Last? next;
  Last? last;

  Map<String, dynamic> toJson() => {
        "next": next ?? next!.toJson(),
        "last": last ?? last!.toJson(),
      };
}

class Last {
  Last({
    this.href,
  });

  factory Last.fromJson(final Map<String, dynamic> json) => Last(
        href: json["href"] as String?,
      );

  String? href;

  Map<String, dynamic> toJson() => {
        "href": href,
      };
}

class EnumValues<T> {
  Map<String, T> map;
  Map<T, String> reverseMap = {};

  // ignore: sort_constructors_first
  EnumValues(this.map);

  Map<T, String> get reverse {
    // ignore: prefer_conditional_assignment
    if (reverseMap == null) {
      reverseMap = map.map((final k, final v) => MapEntry(v, k));
    }
    return reverseMap;
  }
}
