// ignore_for_file: avoid_dynamic_calls, constant_identifier_names, unnecessary_lambdas, prefer_final_parameters

part of kitcod_uikit_flutter;

List<Communities> communitiesFromJson(String str) => List<Communities>.from(
    json.decode(str).map((x) => Communities.fromJson(x as Map<String, dynamic>))
        as Iterable<dynamic>);

class Communities {
  Communities({
    this.uuid,
    this.id,
    this.statusCode,
    this.body,
    this.active,
    this.httpMethod,
  });

  factory Communities.fromJson(Map<String, dynamic> json) => Communities(
        uuid: json["uuid"] as String?,
        id: json["id"] as String?,
        httpMethod: json["httpMethod"] == null
            ? null
            : httpMethodValues.map[json["httpMethod"]],
        statusCode: json["statusCode"] as String?,
        body: json["body"] == null
            ? null
            : CommunitiesList.fromJson(json["body"] as Map<String, dynamic>),
        active: json["active"] as bool? ?? false,
      );

  String? uuid;
  String? id;
  HttpMethod? httpMethod;
  String? statusCode;
  CommunitiesList? body;
  bool? active;
}

class Tag {
  Tag({
    this.uuid,
    this.name,
    this.slug,
    this.auto,
    this.replicate,
    this.active,
  });

  factory Tag.fromJson(Map<String, dynamic> json) => Tag(
        uuid: json["uuid"] as String?,
        name: json["name"] as String?,
        slug: json["slug"] as String?,
        auto: json["auto"] as bool? ?? false,
        replicate: json["replicate"] as bool? ?? false,
        active: json["active"] as bool? ?? false,
      );

  String? uuid;
  String? name;
  String? slug;
  bool? auto;
  bool? replicate;
  bool? active;

  Map<String, dynamic> toJson() => {
        "uuid": uuid,
        "name": name,
        "slug": slug,
        "auto": auto,
        "replicate": replicate,
        "active": active,
      };
}

enum HttpMethod { GET }

final httpMethodValues = EnumValues({"Get": HttpMethod.GET});

class CommunitiesList {
  CommunitiesList({
    this.uuid,
    this.createdTs,
    this.updatedTs,
    this.createdBy,
    this.updatedBy,
    this.version,
    this.id,
    this.accountId,
    this.name,
    this.handle,
    this.communityType,
    this.location,
    this.status,
    this.contentVisibilityType,
    this.settings,
    this.media,
    this.eligibility,
    this.registered,
    this.business,
    this.active,
    this.description,
    this.contactPoints,
    this.hidden,
    this.sect,
    this.tags,
    this.rangeMembersCount,
    this.creationSourceType,
    this.socialConnections,
    this.metadata,
    this.verified,
    this.premium,
    this.facilities,
  });

  factory CommunitiesList.fromJson(final Map<String, dynamic> json) =>
      CommunitiesList(
        uuid: json["uuid"] as String?,
        createdTs: json["createdTS"] as String?,
        updatedTs: json["updatedTS"] as String?,
        createdBy: json["createdBy"] as String?,
        updatedBy: json["updatedBy"] as String?,
        version: json["version"] as int?,
        id: json["id"] as String?,
        accountId: json["accountId"] as int?,
        name: json["name"] as String?,
        sect: json["sect"] as String?,
        handle: json["handle"] as String?,
        communityType: json["communityType"] as String?,
        location: json["location"] == null
            ? null
            : Location.fromJson(json["location"] as Map<String, dynamic>),
        contactPoints: json["contactPoints"] == null
            ? null
            : List<dynamic>.from(
                json["contactPoints"].map((final x) => x) as Iterable<dynamic>),
        status: json["status"] as String?,
        creationSourceType: json["creationSourceType"] as String?,
        rangeMembersCount: json["rangeMembersCount"] as int?,
        contentVisibilityType: json["contentVisibilityType"] as String?,
        settings: json["settings"] == null
            ? null
            : List<Setting>.from(
                // ignore: prefer_final_parameters, unnecessary_lambdas
                json["settings"].map((final x) =>
                        Setting.fromJson(x as Map<String, dynamic>))
                    as Iterable<dynamic>),
        media: json["media"] == null
            ? null
            : CoverMedia.fromJson(json["media"] as Map<String, dynamic>),
        tags: json["tags"] == null
            ? null
            : List<Tag>.from(
                json["tags"].map((x) => Tag.fromJson(x as Map<String, dynamic>))
                    as Iterable<dynamic>),
        eligibility: Eligibility.fromJson(),
        hidden: json["hidden"] as bool? ?? false,
        registered: json["registered"] as bool? ?? false,
        business: json["business"] as bool? ?? false,
        active: json["active"] as bool? ?? false,
        description: json["description"] as String?,
        facilities: json["facilities"] == null
            ? null
            : List<Facility>.from(json["facilities"].map(
                    (final x) => Facility.fromJson(x as Map<String, dynamic>))
                as Iterable<dynamic>),
        socialConnections: json["socialConnections"] == null
            ? null
            : List<SocialConnection>.from(json["socialConnections"].map(
                    (x) => SocialConnection.fromJson(x as Map<String, dynamic>))
                as Iterable<dynamic>),
        metadata: json["metadata"] == null
            ? null
            : CommunityListMetadata.fromJson(
                json["metadata"] as Map<String, dynamic>),
        verified: json["verified"] as bool? ?? false,
        premium: json["premium"] as bool? ?? false,
      );

  String? uuid;
  String? createdTs;
  String? updatedTs;
  String? createdBy;
  String? updatedBy;
  int? version;
  String? id;
  int? accountId;
  String? name;
  String? sect;
  String? handle;
  String? communityType;
  Location? location;
  List<dynamic>? contactPoints;
  String? status;
  String? creationSourceType;
  int? rangeMembersCount;
  String? contentVisibilityType;
  List<Setting>? settings;
  CoverMedia? media;
  List<dynamic>? tags;
  Eligibility? eligibility;
  bool? hidden;
  bool? registered;
  bool? business;
  bool? active;
  String? description;
  List<Facility>? facilities;
  List<SocialConnection>? socialConnections;
  CommunityListMetadata? metadata;
  bool? verified;
  bool? premium;

  Map<String, dynamic> toJson() => {
        "uuid": uuid,
        "createdTS": createdTs,
        "updatedTS": updatedTs,
        "createdBy": createdBy,
        "updatedBy": updatedBy,
        "version": version,
        "id": id,
        "accountId": accountId,
        "name": name,
        "sect": sect,
        "handle": handle,
        "communityType": communityType,
        "location": location ==null?null:location!.toJson(),
        "contactPoints": contactPoints ==null?null:
            List<dynamic>.from(contactPoints!.map((final x) => x)),
        "status": status,
        "creationSourceType": creationSourceType,
        "rangeMembersCount": rangeMembersCount,
        "contentVisibilityType": contentVisibilityType,
        "settings": settings ==null?null:
            List<dynamic>.from(settings!.map((final x) => x.toJson())),
        "media": media ?? media!.toJson(),
        "tags": tags ==null?null: List<dynamic>.from(tags!.map((x) => x.toJson())),
        "eligibility": eligibility!.toJson(),
        "hidden": hidden,
        "registered": registered,
        "business": business,
        "active": active,
        "description": description,
        "facilities": facilities ==null?null:
            List<dynamic>.from(facilities!.map((final x) => x.toJson())),
        "socialConnections": socialConnections ==null?null:
            List<dynamic>.from(socialConnections!.map((final x) => x.toJson())),
        "metadata": metadata ==null?null: metadata!.toJson(),
        "verified": verified,
        "premium": premium,
      };
}

class Eligibility {
  Eligibility();

  factory Eligibility.fromJson() => Eligibility();

  Map<String, dynamic> toJson() => {};
}

class Facility {
  Facility({
    this.uuid,
    this.description,
    this.type,
    this.active,
  });

  factory Facility.fromJson(final Map<String, dynamic> json) => Facility(
        uuid: json["uuid"] as String?,
        description: json["description"] as String?,
        type: json["type"] as String?,
        active: json["active"] as bool? ?? false,
      );

  String? uuid;
  String? description;
  String? type;
  bool? active;

  Map<String, dynamic> toJson() => {
        "uuid": uuid,
        "description": description,
        "type": type,
        "active": active,
      };
}

class Location {
  Location({
    this.uuid,
    this.geoCoordinates,
    this.address,
    this.active,
    this.gplaceId,
    this.version,
  });
  factory Location.fromJson(final Map<String, dynamic> json) => Location(
        uuid: json["uuid"] as String?,
        geoCoordinates: json["geoCoordinates"] == null
            ? null
            : GeoCoordinates.fromJson(
                json["geoCoordinates"] as Map<String, dynamic>),
        address: json["address"] == null
            ? null
            : Address.fromJson(json["address"] as Map<String, dynamic>),
        gplaceId: json["gplaceId"] as String?,
        active: json["active"] as bool? ?? false,
        version: json["version"] as int?,
      );

  String? uuid;
  GeoCoordinates? geoCoordinates;
  Address? address;
  String? gplaceId;
  bool? active;
  int? version;

  Map<String, dynamic> toJson() => {
        "uuid": uuid,
        "geoCoordinates": geoCoordinates ?? geoCoordinates!.toJson(),
        "address": address ?? address!.toJson(),
        "gplaceId": gplaceId,
        "active": active,
        "version": version,
      };
}

class Address {
  Address({
    this.uuid,
    this.addressLine1,
    this.displayAddressLine,
    this.city,
    this.active,
    this.country,
    this.version,
    this.state,
    this.zipcode,
  });
  factory Address.fromJson(final Map<String, dynamic> json) => Address(
        uuid: json["uuid"] as String?,
        addressLine1: json["addressLine1"] as String?,
        displayAddressLine: json["displayAddressLine"] as String?,
        city: json["city"] as String?,
        country:
            json["country"] == null ? null : countryValues.map[json["country"]],
        active: json["active"] as bool? ?? false,
        zipcode: json["zipcode"] as String?,
        version: json["version"] as int?,
        state: json["state"] as String?,
      );
  String? uuid;
  String? addressLine1;
  String? displayAddressLine;
  String? city;
  Country? country;
  bool? active;
  String? zipcode;
  int? version;
  String? state;

  Map<String, dynamic> toJson() => {
        "uuid": uuid,
        "addressLine1": addressLine1,
        "displayAddressLine": displayAddressLine,
        "city": city,
        "country": country ?? countryValues.reverse[country],
        "active": active,
        "zipcode": zipcode,
        "version": version,
        "state": state,
      };
}

enum Country {
  INDIA,
  UNITED_STATES,
  OMAN,
  PAKISTAN,
  QATAR,
  UNITED_ARAB_EMIRATES,
  ANGOLA,
  UGANDA,
  TANZANIA,
  AUSTRALIA,
  CANADA,
  SAUDI_ARABIA
}

final countryValues = EnumValues({
  "Angola": Country.ANGOLA,
  "Australia": Country.AUSTRALIA,
  "Canada": Country.CANADA,
  "India": Country.INDIA,
  "Oman": Country.OMAN,
  "Pakistan": Country.PAKISTAN,
  "Qatar": Country.QATAR,
  "Saudi Arabia": Country.SAUDI_ARABIA,
  "Tanzania": Country.TANZANIA,
  "Uganda": Country.UGANDA,
  "United Arab Emirates": Country.UNITED_ARAB_EMIRATES,
  "United States": Country.UNITED_STATES
});

class GeoCoordinates {
  GeoCoordinates({
    this.type,
    this.coordinates,
    this.latitude,
    this.longitude,
  });

  factory GeoCoordinates.fromJson(final Map<String, dynamic> json) =>
      GeoCoordinates(
        type: json["type"] as String?,
        coordinates: json["coordinates"] == null
            ? null
            : List<double>.from(json["coordinates"]
                .map((final x) => x.toDouble()) as Iterable<dynamic>),
        latitude: json["latitude"] as String?,
        longitude: json["longitude"] as String?,
      );

  String? type;
  List<double>? coordinates;
  String? latitude;
  String? longitude;

  Map<String, dynamic> toJson() => {
        "type": type,
        "coordinates":
            coordinates ?? List<dynamic>.from(coordinates!.map((final x) => x)),
        "latitude": latitude,
        "longitude": longitude,
      };
}

class CoverMedia {
  CoverMedia({
    this.proImg,
    this.covImg,
  });

  factory CoverMedia.fromJson(final Map<String, dynamic> json) => CoverMedia(
        proImg: json["proImg"] == null
            ? null
            : Img.fromJson(json["proImg"] as Map<String, dynamic>),
        covImg: json["covImg"] == null
            ? null
            : Img.fromJson(json["covImg"] as Map<String, dynamic>),
      );

  Img? proImg;
  Img? covImg;

  Map<String, dynamic> toJson() => {
        "proImg": proImg ?? proImg!.toJson(),
        "covImg": covImg ?? covImg!.toJson(),
      };
}

class Img {
  Img({
    this.uuid,
    this.id,
    this.resourceType,
    this.type,
    this.resizedMediaList,
    this.active,
    this.resourceId,
    this.contentType,
  });
  factory Img.fromJson(final Map<String, dynamic> json) => Img(
        uuid: json["uuid"] as String?,
        id: json["id"] as String?,
        resourceType: json["resourceType"] as String?,
        resourceId: json["resourceId"] as String?,
        type: json["type"] as String?,
        contentType: json["contentType"] as String?,
        resizedMediaList: json["resizedMediaList"] == null
            ? null
            : List<ResizedMediaList>.from(json["resizedMediaList"].map(
                    (x) => ResizedMediaList.fromJson(x as Map<String, dynamic>))
                as Iterable<dynamic>),
        active: json["active"] as bool? ?? false,
      );
  String? uuid;
  String? id;
  String? resourceType;
  String? resourceId;
  String? type;
  String? contentType;
  List<ResizedMediaList>? resizedMediaList;
  bool? active;

  Map<String, dynamic> toJson() => {
        "uuid": uuid,
        "id": id,
        "resourceType": resourceType,
        "resourceId": resourceId,
        "type": type,
        "contentType": contentType,
        "resizedMediaList": resizedMediaList ??
            List<dynamic>.from(resizedMediaList!.map((final x) => x.toJson())),
        "active": active,
      };
}

class ResizedGroupMediaList {
  ResizedGroupMediaList({
    this.type,
    this.mediaUrl,
  });

  factory ResizedGroupMediaList.fromJson(final Map<String, dynamic> json) =>
      ResizedGroupMediaList(
        type: json["type"] as String?,
        mediaUrl: json["mediaUrl"] as String?,
      );

  String? type;
  String? mediaUrl;

  Map<String, dynamic> toJson() => {
        "type": type,
        "mediaUrl": mediaUrl,
      };
}

class CommunityListMetadata {
  CommunityListMetadata({
    this.mdGroupChannels,
    this.mdIntelliRsvpSetting,
  });

  factory CommunityListMetadata.fromJson(final Map<String, dynamic> json) =>
      CommunityListMetadata(
        mdGroupChannels: json["mdGroupChannels"] == null
            ? null
            : List<MdGroupChannel>.from(json["mdGroupChannels"].map(
                    (x) => MdGroupChannel.fromJson(x as Map<String, dynamic>))
                as Iterable<dynamic>),
        mdIntelliRsvpSetting: json["mdIntelliRSVPSetting"] == null
            ? null
            : MdIntelliRsvpSetting.fromJson(
                json["mdIntelliRSVPSetting"] as Map<String, dynamic>),
      );

  List<MdGroupChannel>? mdGroupChannels;
  MdIntelliRsvpSetting? mdIntelliRsvpSetting;

  Map<String, dynamic> toJson() => {
        "mdGroupChannels": mdGroupChannels ??
            List<dynamic>.from(mdGroupChannels!.map((final x) => x.toJson())),
        "mdIntelliRSVPSetting":
            mdIntelliRsvpSetting ?? mdIntelliRsvpSetting!.toJson(),
      };
}

class MdGroupChannel {
  MdGroupChannel({
    this.name,
    this.coverUrl,
    this.channelUrl,
    this.customType,
    this.isDistinct,
    this.isPublic,
    this.isEphemeral,
    this.data,
    this.isCreated,
    this.isDiscoverable,
    this.isSuper,
    this.freeze,
    this.memberCount,
    this.joinedMemberCount,
    this.maxLengthMessage,
    this.createdAt,
    this.members,
    this.uuid,
    this.active,
    this.createdTs,
    this.updatedTs,
    this.createdBy,
    this.updatedBy,
    this.communityId,
    this.operators,
  });

  factory MdGroupChannel.fromJson(final Map<String, dynamic> json) =>
      MdGroupChannel(
        name: json["name"] as String?,
        coverUrl: json["cover_url"] as String?,
        channelUrl: json["channel_url"] as String?,
        customType: json["custom_type"] as String?,
        isDistinct: json["is_distinct"] as bool? ?? false,
        isPublic: json["is_public"] as bool? ?? false,
        isEphemeral: json["is_ephemeral"] as bool? ?? false,
        data: json["data"] as String?,
        isCreated: json["is_created"] as bool? ?? false,
        isDiscoverable: json["is_discoverable"] as bool? ?? false,
        isSuper: json["is_super"] as bool? ?? false,
        freeze: json["freeze"] as bool? ?? false,
        memberCount: json["member_count"] as int?,
        joinedMemberCount: json["joined_member_count"] as int?,
        maxLengthMessage: json["max_length_message"] as int?,
        createdAt: json["created_at"] as int?,
        operators: json["operators"] == null
            ? null
            : List<Operator>.from(json["operators"]
                    .map((x) => Operator.fromJson(x as Map<String, dynamic>))
                as Iterable<dynamic>),
        members: json["members"] == null
            ? null
            : List<Member>.from(json["members"]
                    .map((x) => Member.fromJson(x as Map<String, dynamic>))
                as Iterable<dynamic>),
        uuid: json["uuid"] as String?,
        active: json["active"] as bool? ?? false,
        createdTs: json["created_ts"] as String?,
        updatedTs: json["updated_ts"] as String?,
        createdBy: json["created_by"] as String?,
        updatedBy: json["updated_by"] as String?,
        communityId: json["community_id"] as String?,
      );
  String? name;
  String? coverUrl;
  String? channelUrl;
  String? customType;
  bool? isDistinct;
  bool? isPublic;
  bool? isEphemeral;
  String? data;
  bool? isCreated;
  bool? isDiscoverable;
  bool? isSuper;
  bool? freeze;
  int? memberCount;
  int? joinedMemberCount;
  int? maxLengthMessage;
  int? createdAt;
  List<Operator>? operators;
  List<Member>? members;
  String? uuid;
  bool? active;
  String? createdTs;
  String? updatedTs;
  String? createdBy;
  String? updatedBy;
  String? communityId;

  Map<String, dynamic> toJson() => {
        "name": name,
        "cover_url": coverUrl,
        "channel_url": channelUrl,
        "custom_type": customType,
        "is_distinct": isDistinct,
        "is_public": isPublic,
        "is_ephemeral": isEphemeral,
        "data": data,
        "is_created": isCreated,
        "is_discoverable": isDiscoverable,
        "is_super": isSuper,
        "freeze": freeze,
        "member_count": memberCount,
        "joined_member_count": joinedMemberCount,
        "max_length_message": maxLengthMessage,
        "created_at": createdAt,
        "operators": operators ??
            List<dynamic>.from(operators!.map((final x) => x.toJson())),
        "members": members ??
            List<dynamic>.from(members!.map((final x) => x.toJson())),
        "uuid": uuid,
        "active": active,
        "created_ts": createdTs,
        "updated_ts": updatedTs,
        "created_by": createdBy,
        "updated_by": updatedBy,
        "community_id": communityId,
      };
}

class Member {
  Member({
    this.userId,
    this.nickname,
    this.profileUrl,
    this.metadata,
    this.isActive,
    this.isOnline,
    this.lastSeenAt,
  });

  factory Member.fromJson(final Map<String, dynamic> json) => Member(
        userId: json["user_id"] as String?,
        nickname: json["nickname"] as String?,
        profileUrl: json["profile_url"] as String?,
        metadata: json["metadata"] == null
            ? null
            : MemberMetadata.fromJson(json["metadata"] as Map<String, dynamic>),
        isActive: json["is_active"] as bool? ?? false,
        isOnline: json["is_online"] as bool? ?? false,
        lastSeenAt: json["last_seen_at"] as int?,
      );

  String? userId;
  String? nickname;
  String? profileUrl;
  MemberMetadata? metadata;
  bool? isActive;
  bool? isOnline;
  int? lastSeenAt;

  Map<String, dynamic> toJson() => {
        "user_id": userId,
        "nickname": nickname,
        "profile_url": profileUrl,
        "metadata": metadata ?? metadata!.toJson(),
        "is_active": isActive,
        "is_online": isOnline,
        "last_seen_at": lastSeenAt,
      };
}

class MemberMetadata {
  MemberMetadata({
    this.homeCountry,
  });
  factory MemberMetadata.fromJson(final Map<String, dynamic> json) =>
      MemberMetadata(
        homeCountry: json["homeCountry"] == null
            ? null
            : countryValues.map[json["homeCountry"]],
      );
  Country? homeCountry;

  Map<String, dynamic> toJson() => {
        "homeCountry": homeCountry ?? countryValues.reverse[homeCountry],
      };
}

class Operator {
  Operator({
    this.userId,
    this.nickname,
    this.profileUrl,
    this.metadata,
    this.isActive,
    this.isOnline,
    this.lastSeenAt,
  });
  factory Operator.fromJson(final Map<String, dynamic> json) => Operator(
        userId: json["user_id"] as String?,
        nickname: json["nickname"] as String?,
        profileUrl: json["profile_url"] as String?,
        metadata: Eligibility.fromJson(),
        isActive: json["is_active"] as bool? ?? false,
        isOnline: json["is_online"] as bool? ?? false,
        lastSeenAt: json["last_seen_at"] as int?,
      );
  String? userId;
  String? nickname;
  String? profileUrl;
  Eligibility? metadata;
  bool? isActive;
  bool? isOnline;
  int? lastSeenAt;

  Map<String, dynamic> toJson() => {
        "user_id": userId,
        "nickname": nickname,
        "profile_url": profileUrl,
        "metadata": metadata ?? metadata!.toJson(),
        "is_active": isActive,
        "is_online": isOnline,
        "last_seen_at": lastSeenAt,
      };
}

class MdIntelliRsvpSetting {
  MdIntelliRsvpSetting({
    this.approvalType,
    this.attendeesCount,
    this.finalizeEventTs,
    this.hoursBeforeStartFinalizeEvent,
  });
  factory MdIntelliRsvpSetting.fromJson(final Map<String, dynamic> json) =>
      MdIntelliRsvpSetting(
        approvalType: json["approvalType"] as String?,
        attendeesCount: json["attendeesCount"] as int?,
        finalizeEventTs: json["finalizeEventTS"] as String?,
        hoursBeforeStartFinalizeEvent:
            json["hoursBeforeStartFinalizeEvent"] as int?,
      );
  String? approvalType;
  int? attendeesCount;
  String? finalizeEventTs;
  int? hoursBeforeStartFinalizeEvent;

  Map<String, dynamic> toJson() => {
        "approvalType": approvalType,
        "attendeesCount": attendeesCount,
        "finalizeEventTS": finalizeEventTs,
        "hoursBeforeStartFinalizeEvent": hoursBeforeStartFinalizeEvent,
      };
}

class Setting {
  Setting({
    this.uuid,
    this.updatedTs,
    this.createdBy,
    this.updatedBy,
    this.createdTs,
    this.key,
    this.value,
    this.active,
  });
  factory Setting.fromJson(final Map<String, dynamic> json) => Setting(
        uuid: json["uuid"] as String?,
        createdTs: json["createdTS"] as String?,
        updatedTs: json["updatedTS"] as String?,
        createdBy: json["createdBy"] as String?,
        updatedBy: json["updatedBy"] as String?,
        key: json["key"] as String?,
        value: json["value"] as String?,
        active: json["active"] as bool? ?? false,
      );

  String? uuid;
  String? createdTs;
  String? updatedTs;
  String? createdBy;
  String? updatedBy;
  String? key;
  String? value;
  bool? active;

  Map<String, dynamic> toJson() => {
        "uuid": uuid,
        "createdTS": createdTs,
        "updatedTS": updatedTs,
        "createdBy": createdBy,
        "updatedBy": updatedBy,
        "key": key,
        "value": value,
        "active": active,
      };
}

class SocialConnection {
  SocialConnection({
    this.url,
  });
  factory SocialConnection.fromJson(final Map<String, dynamic> json) =>
      SocialConnection(
        url: json["url"] as String?,
      );
  String? url;

  Map<String, dynamic> toJson() => {
        "url": url,
      };
}
