// ignore_for_file: unnecessary_lambdas, avoid_dynamic_calls

part of kitcod_uikit_flutter;

UserCommunityRelationshipList userCommunityRelationshipListFromJson(
        final String str) =>
    UserCommunityRelationshipList.fromJson(
        json.decode(str) as Map<String, dynamic>);

String userCommunityRelationshipListToJson(
        final UserCommunityRelationshipList data) =>
    json.encode(data.toJson());

class UserCommunityRelationshipList {
  UserCommunityRelationshipList({
    this.embedded,
    this.page,
  });

  factory UserCommunityRelationshipList.fromJson(
          final Map<String, dynamic> json) =>
      UserCommunityRelationshipList(
        embedded: json["_embedded"] == null
            ? null
            : EmbeddedCommunities.fromJson(
                json["_embedded"] as Map<String, dynamic>),
        page: json["page"] == null
            ? null
            : Page.fromJson(json["page"] as Map<String, dynamic>),
      );

  EmbeddedCommunities? embedded;
  Page? page;

  Map<String, dynamic> toJson() => {
        "_embedded": embedded ?? embedded!.toJson(),
        "page": page ?? page!.toJson(),
      };
}

class EmbeddedCommunities {
  EmbeddedCommunities({
    this.userCommunityRelationshipList,
  });

  factory EmbeddedCommunities.fromJson(final Map<String, dynamic> json) =>
      EmbeddedCommunities(
        userCommunityRelationshipList:
            json["userCommunityRelationshipList"] == null
                ? null
                : List<UserCommunityRelationshipListElement>.from(
                    json["userCommunityRelationshipList"].map((final x) =>
                        UserCommunityRelationshipListElement.fromJson(
                            x as Map<String, dynamic>)) as Iterable<dynamic>),
      );

  List<UserCommunityRelationshipListElement>? userCommunityRelationshipList;

  Map<String, dynamic> toJson() => {
        "userCommunityRelationshipList": userCommunityRelationshipList ??
            List<dynamic>.from(
                userCommunityRelationshipList!.map((final x) => x.toJson())),
      };
}

class UserCommunityRelationshipListElement {
  UserCommunityRelationshipListElement({
    this.uuid,
    this.createdTs,
    this.updatedTs,
    this.createdBy,
    this.updatedBy,
    this.version,
    this.userId,
    this.communityId,
    this.status,
    this.userCommunityRoles,
    this.invitedBy,
    this.eligibility,
    this.user,
    this.active,
    this.businessCommunity,
    this.keyMember,
    this.premium,
  });

  factory UserCommunityRelationshipListElement.fromJson(
          final Map<String, dynamic> json) =>
      UserCommunityRelationshipListElement(
        uuid: json["uuid"] as String?,
        createdTs: json["createdTS"] as String?,
        updatedTs: json["updatedTS"] as String?,
        createdBy: json["createdBy"] as String?,
        updatedBy: json["updatedBy"] as String?,
        version: json["version"] as int?,
        userId: json["userId"] as String?,
        communityId: json["communityId"] as String?,
        status: json["status"] as String?,
        userCommunityRoles: json["userCommunityRoles"] == null
            ? null
            : List<UserCommunityRole>.from(json["userCommunityRoles"].map(
                    (final x) =>
                        UserCommunityRole.fromJson(x as Map<String, dynamic>))
                as Iterable<dynamic>),
        invitedBy: json["invitedBy"] as String?,
        eligibility: Eligibility.fromJson(),
        user: json["user"] == null
            ? null
            : UserProfile.fromJson(json["user"] as Map<String, dynamic>),
        active: json["active"] as bool?,
        businessCommunity: json["businessCommunity"] as bool?,
        keyMember: json["keyMember"] as bool?,
        premium: json["premium"] as bool?,
      );

  String? uuid;
  String? createdTs;
  String? updatedTs;
  String? createdBy;
  String? updatedBy;
  int? version;
  String? userId;
  String? communityId;
  String? status;
  List<UserCommunityRole>? userCommunityRoles;
  String? invitedBy;
  Eligibility? eligibility;
  UserProfile? user;
  bool? active;
  bool? businessCommunity;
  bool? keyMember;
  bool? premium;

  Map<String, dynamic> toJson() => {
        "uuid": uuid,
        "createdTS": createdTs,
        "updatedTS": updatedTs,
        "createdBy": createdBy,
        "updatedBy": updatedBy,
        "version": version,
        "userId": userId,
        "communityId": communityId,
        "status": status,
        "userCommunityRoles": userCommunityRoles ??
            List<dynamic>.from(
                userCommunityRoles!.map((final x) => x.toJson())),
        "invitedBy": invitedBy,
        "eligibility": eligibility ?? eligibility!.toJson(),
        "user": user?.toJson() ?? {},
        "active": active,
        "businessCommunity": businessCommunity,
        "keyMember": keyMember,
        "premium": premium,
      };
}

class UserCommunityRole {
  UserCommunityRole({
    this.uuid,
    this.createdTs,
    this.updatedTs,
    this.createdBy,
    this.updatedBy,
    this.role,
    this.active,
  });

  factory UserCommunityRole.fromJson(final Map<String, dynamic> json) =>
      UserCommunityRole(
        uuid: json["uuid"] as String?,
        createdTs: json["createdTS"] as String?,
        updatedTs: json["updatedTS"] as String?,
        createdBy: json["createdBy"] as String?,
        updatedBy: json["updatedBy"] as String?,
        role: json["role"] as String?,
        active: json["active"] as bool?,
      );

  String? uuid;
  String? createdTs;
  String? updatedTs;
  String? createdBy;
  String? updatedBy;
  String? role;
  bool? active;

  Map<String, dynamic> toJson() => {
        "uuid": uuid,
        "createdTS": createdTs,
        "updatedTS": updatedTs,
        "createdBy": createdBy,
        "updatedBy": updatedBy,
        "role": role,
        "active": active,
      };
}
