// ignore_for_file: avoid_dynamic_calls, unnecessary_lambdas, prefer_if_null_operators

part of kitcod_uikit_flutter;

List<Reporting> reportingFromJson(final String str) => List<Reporting>.from(json
        .decode(str)
        .map((final x) => Reporting.fromJson(x as Map<String, dynamic>))
    as Iterable<dynamic>);

String reportingToJson(final List<Reporting> data) =>
    json.encode(List<dynamic>.from(data.map((final x) => x.toJson())));

class Reporting {
  Reporting({
    this.lang,
    this.options,
  });

  factory Reporting.fromJson(final Map<String, dynamic> json) => Reporting(
        lang: json["lang"] as String?,
        options: json["options"] == null
            ? null
            : List<ReportingOption>.from(json["options"].map((final x) =>
                    ReportingOption.fromJson(x as Map<String, dynamic>))
                as Iterable<dynamic>),
      );

  String? lang;
  List<ReportingOption>? options;

  Map<String, dynamic> toJson() => {
        "lang": lang,
        "options": options ??
            List<dynamic>.from(options!.map((final x) => x.toJson())),
      };
}

class ReportingOption {
  ReportingOption({
    this.id,
    this.type,
    this.desc,
    this.help,
    this.textRequired,
    this.subReasons,
    this.textHelp,
  });

  factory ReportingOption.fromJson(final Map<String, dynamic> json) =>
      ReportingOption(
        id: json["id"] as String?,
        type: json["type"] as String?,
        desc: json["desc"] as String?,
        help: json["help"] as String?,
        textRequired: json["textRequired"] as bool?,
        subReasons: json["subReasons"] == null
            ? null
            : List<ReportingOption>.from(json["subReasons"].map((final x) =>
                    ReportingOption.fromJson(x as Map<String, dynamic>))
                as Iterable<dynamic>),
        textHelp: json["textHelp"] as String?,
      );

  String? id;
  String? type;
  String? desc;
  String? help;
  bool? textRequired;
  List<ReportingOption>? subReasons;
  String? textHelp;

  Map<String, dynamic> toJson() => {
        "id": id,
        "type": type,
        "desc": desc,
        "help": help,
        "textRequired": textRequired,
        "subReasons": subReasons ??
            List<dynamic>.from(subReasons!.map((final x) => x.toJson())),
        "textHelp": textHelp ?? textHelp,
      };
}
