// ignore_for_file: sort_constructors_first, avoid_dynamic_calls, unnecessary_lambdas, constant_identifier_names, prefer_if_null_operators, avoid_unused_constructor_parameters

part of kitcod_uikit_flutter;

UserProfile userProfileFromJson(final String str) =>
    UserProfile.fromJson(json.decode(str) as Map<String, dynamic>);

String userProfileToJson(final UserProfile data) => json.encode(data.toJson());

class UserProfile {
  UserProfile({
    this.uuid,
    this.createdTs,
    this.updatedTs,
    this.createdBy,
    this.updatedBy,
    this.version,
    this.id,
    this.media,
    this.extProfileImgUrl,
    this.firstName,
    this.lastName,
    this.gender,
    this.yob,
    this.authProviders,
    this.homeLocation,
    this.contactPoints,
    this.premiumUntilTs,
    this.type,
    this.metadata,
    this.registeredTs,
    this.devices,
    this.userCommunities,
    this.userCommunitiesNegative,
    this.policyAcceptances,
    this.active,
  });

  String? uuid;
  String? createdTs;
  String? updatedTs;
  String? createdBy;
  String? updatedBy;
  int? version;
  String? id;
  String? extProfileImgUrl;
  CoverMedia? media;
  String? firstName;
  String? lastName;
  int? gender;
  int? yob;
  List<AuthProvider>? authProviders;
  HomeLocation? homeLocation;
  List<ContactPoint>? contactPoints;
  String? premiumUntilTs;
  String? type;
  UserProfileMetadata? metadata;
  String? registeredTs;
  List<Device>? devices;
  List<UserCommunit>? userCommunities;
  List<UserCommunit>? userCommunitiesNegative;
  List<PolicyAcceptance>? policyAcceptances;
  bool? active;

  factory UserProfile.fromJson(final Map<String, dynamic> json) => UserProfile(
        uuid: json["uuid"] as String?,
        createdTs: json["createdTS"] as String?,
        updatedTs: json["updatedTS"] as String?,
        createdBy: json["createdBy"] as String?,
        updatedBy: json["updatedBy"] as String?,
        version: json["version"] as int?,
        id: json["id"] as String?,
        extProfileImgUrl: json["extProfileImgUrl"] as String?,
        media: json["media"] == null
            ? null
            : CoverMedia.fromJson(json["media"] as Map<String, dynamic>),
        firstName: json["firstName"] as String?,
        lastName: json["lastName"] as String?,
        gender: json["gender"] as int?,
        yob: json["yob"] as int?,
        authProviders: json["authProviders"] == null
            ? null
            : List<AuthProvider>.from(json["authProviders"].map((final x) =>
                    AuthProvider.fromJson(x as Map<String, dynamic>))
                as Iterable<dynamic>),
        homeLocation: json["homeLocation"] == null
            ? null
            : HomeLocation.fromJson(
                json["homeLocation"] as Map<String, dynamic>),
        contactPoints: json["contactPoints"] == null
            ? null
            : List<ContactPoint>.from(json["contactPoints"].map((final x) =>
                    ContactPoint.fromJson(x as Map<String, dynamic>))
                as Iterable<dynamic>),
        premiumUntilTs: json["premiumUntilTS"] as String?,
        type: json["type"] as String?,
        metadata: json["metadata"] == null
            ? null
            : UserProfileMetadata.fromJson(
                json["metadata"] as Map<String, dynamic>),
        registeredTs: json["registeredTS"] as String?,
        devices: json["devices"] == null
            ? null
            : List<Device>.from(json["devices"].map(
                    (final x) => Device.fromJson(x as Map<String, dynamic>))
                as Iterable<dynamic>),
        userCommunities: json["userCommunities"] == null
            ? null
            : List<UserCommunit>.from(json["userCommunities"].map((final x) =>
                    UserCommunit.fromJson(x as Map<String, dynamic>))
                as Iterable<dynamic>),
        userCommunitiesNegative: json["userCommunitiesNegative"] == null
            ? null
            : List<UserCommunit>.from(json["userCommunitiesNegative"].map(
                    (final x) =>
                        UserCommunit.fromJson(x as Map<String, dynamic>))
                as Iterable<dynamic>),
        policyAcceptances: json["policyAcceptances"] == null
            ? null
            : List<PolicyAcceptance>.from(json["policyAcceptances"].map(
                    (final x) =>
                        PolicyAcceptance.fromJson(x as Map<String, dynamic>))
                as Iterable<dynamic>),
        active: json["active"] as bool?,
      );

  Map<String, dynamic> toJson() => {
        "uuid": uuid,
        "createdTS": createdTs,
        "updatedTS": updatedTs,
        "createdBy": createdBy,
        "updatedBy": updatedBy,
        "version": version,
        "id": id,
        "extProfileImgUrl": extProfileImgUrl,
        "media": media ?? media!.toJson(),
        "firstName": firstName,
        "lastName": lastName,
        "gender": gender,
        "yob": yob,
        "authProviders": authProviders,
        "homeLocation": homeLocation ?? homeLocation!.toJson(),
        "contactPoints": contactPoints ??
            List<dynamic>.from(contactPoints!.map((final x) => x.toJson())),
        "premiumUntilTS": premiumUntilTs,
        "type": type,
        "metadata": metadata ?? metadata!.toJson(),
        "registeredTS": registeredTs,
        "devices": devices ??
            List<dynamic>.from(devices!.map((final x) => x.toJson())),
        "userCommunities": userCommunities ??
            List<dynamic>.from(userCommunities!.map((final x) => x.toJson())),
        "userCommunitiesNegative": userCommunitiesNegative ??
            List<dynamic>.from(
                userCommunitiesNegative!.map((final x) => x.toJson())),
        "policyAcceptances": policyAcceptances ??
            List<dynamic>.from(policyAcceptances!.map((final x) => x.toJson())),
        "active": active,
      };
}

class AuthProvider {
  AuthProvider({
    this.authProvider,
    this.authUserId,
  });

  String? authProvider;
  String? authUserId;

  factory AuthProvider.fromJson(final Map<String, dynamic> json) =>
      AuthProvider(
        authProvider: json["authProvider"] as String?,
        authUserId: json["authUserId"] as String?,
      );

  Map<String, dynamic> toJson() => {
        "authProvider": authProvider,
        "authUserId": authUserId,
      };
}

class ContactPoint {
  ContactPoint({
    this.type,
    this.value,
  });

  String? type;
  String? value;

  factory ContactPoint.fromJson(final Map<String, dynamic> json) =>
      ContactPoint(
        type: json["type"] as String?,
        value: json["value"] as String?,
      );

  Map<String, dynamic> toJson() => {
        "type": type,
        "value": value,
      };
}

class Device {
  Device({
    this.uuid,
    this.osType,
    this.osVersion,
    this.deviceMake,
    this.deviceVersion,
    this.ppEndPointId,
    this.adTrackingDisabled,
    this.active,
    this.createdTs,
    this.updatedTs,
    this.createdBy,
    this.updatedBy,
    this.deviceType,
    this.deviceAdvertisingId,
    this.ppDeviceToken,
    this.deviceName,
  });

  String? uuid;
  String? osType;
  String? osVersion;
  String? deviceMake;
  String? deviceVersion;
  String? ppEndPointId;
  bool? adTrackingDisabled;
  bool? active;
  String? createdTs;
  String? updatedTs;
  String? createdBy;
  String? updatedBy;
  String? deviceType;
  String? deviceAdvertisingId;
  String? ppDeviceToken;
  String? deviceName;

  factory Device.fromJson(final Map<String, dynamic> json) => Device(
        uuid: json["uuid"] as String?,
        osType: json["osType"] as String?,
        osVersion: json["osVersion"] as String?,
        deviceMake: json["deviceMake"] as String?,
        deviceVersion: json["deviceVersion"] as String?,
        ppEndPointId: json["ppEndPointId"] as String?,
        adTrackingDisabled: json["adTrackingDisabled"] as bool?,
        active: json["active"] as bool?,
        createdTs: json["createdTS"] as String?,
        updatedTs: json["updatedTS"] as String?,
        createdBy: json["createdBy"] as String?,
        updatedBy: json["updatedBy"] as String?,
        deviceType: json["deviceType"] as String?,
        deviceAdvertisingId: json["deviceAdvertisingId"] as String?,
        ppDeviceToken: json["ppDeviceToken"] as String?,
        deviceName: json["deviceName"] as String?,
      );

  Map<String, dynamic> toJson() => {
        "uuid": uuid,
        "osType": osType,
        "osVersion": osVersion,
        "deviceMake": deviceMake,
        "deviceVersion": deviceVersion,
        "ppEndPointId": ppEndPointId,
        "adTrackingDisabled": adTrackingDisabled,
        "active": active,
        "createdTS": createdTs,
        "updatedTS": updatedTs,
        "createdBy": createdBy,
        "updatedBy": updatedBy,
        "deviceType": deviceType,
        "deviceAdvertisingId": deviceAdvertisingId,
        "ppDeviceToken": ppDeviceToken,
        "deviceName": deviceName,
      };
}

class HomeLocation {
  HomeLocation({
    this.uuid,
    this.address,
    this.active,
  });

  String? uuid;
  Address? address;
  bool? active;

  factory HomeLocation.fromJson(final Map<String, dynamic> json) =>
      HomeLocation(
        uuid: json["uuid"] as String?,
        address: json["address"] == null
            ? null
            : Address.fromJson(json["address"] as Map<String, dynamic>),
        active: json["active"] as bool? ?? false,
      );

  Map<String, dynamic> toJson() => {
        "uuid": uuid,
        "address": address ?? address!.toJson(),
        "active": active,
      };
}

enum TypeEnum { THUMBNAIL, RESIZED }

final typeValuesEnum =
    EnumValues({"resized": TypeEnum.RESIZED, "thumbnail": TypeEnum.THUMBNAIL});

class UserProfileMetadata {
  UserProfileMetadata({
    this.mdChatUser,
  });

  MdChatUser? mdChatUser;

  factory UserProfileMetadata.fromJson(final Map<String, dynamic> json) =>
      UserProfileMetadata(
        mdChatUser: json["mdChatUser"] == null
            ? null
            : MdChatUser.fromJson(json["mdChatUser"] as Map<String, dynamic>),
      );

  Map<String, dynamic> toJson() => {
        "mdChatUser": mdChatUser ?? mdChatUser!.toJson(),
      };
}

class MdChatUser {
  MdChatUser({
    this.userId,
    this.nickname,
    this.profileUrl,
    this.phoneNumber,
    this.discoveryKeys,
    this.metadata,
    this.isActive,
    this.hasEverLoggedIn,
    this.isOnline,
    this.lastSeenAt,
    this.sessionToken,
    this.updatedTs,
    this.updatedBy,
    this.version,
  });

  String? userId;
  String? nickname;
  String? profileUrl;
  String? phoneNumber;
  List<dynamic>? discoveryKeys;
  MdChatUserMetadata? metadata;
  bool? isActive;
  bool? hasEverLoggedIn;
  bool? isOnline;
  int? lastSeenAt;
  SessionToken? sessionToken;
  String? updatedTs;
  String? updatedBy;
  int? version;

  factory MdChatUser.fromJson(final Map<String, dynamic> json) => MdChatUser(
        userId: json["user_id"] as String?,
        nickname: json["nickname"] as String?,
        profileUrl: json["profile_url"] as String?,
        phoneNumber: json["phone_number"] as String?,
        discoveryKeys: json["discovery_keys"] == null
            ? null
            : List<dynamic>.from(json["discovery_keys"].map((final x) => x)
                as Iterable<dynamic>),
        metadata: json["metadata"] == null
            ? null
            : MdChatUserMetadata.fromJson(
                json["metadata"] as Map<String, dynamic>),
        isActive: json["is_active"] as bool?,
        hasEverLoggedIn: json["has_ever_logged_in"] as bool?,
        isOnline: json["is_online"] as bool?,
        lastSeenAt: json["last_seen_at"] as int?,
        sessionToken: json["session_token"] == null
            ? null
            : SessionToken.fromJson(
                json["session_token"] as Map<String, dynamic>),
        updatedTs: json["updated_ts"] as String?,
        updatedBy: json["updated_by"] as String?,
        version: json["version"] as int?,
      );

  Map<String, dynamic> toJson() => {
        "user_id": userId,
        "nickname": nickname,
        "profile_url": profileUrl,
        "phone_number": phoneNumber,
        "discovery_keys": discoveryKeys ??
            List<dynamic>.from(discoveryKeys!.map((final x) => x)),
        "metadata": metadata ?? metadata!.toJson(),
        "is_active": isActive,
        "has_ever_logged_in": hasEverLoggedIn,
        "is_online": isOnline,
        "last_seen_at": lastSeenAt,
        "session_token": sessionToken ?? sessionToken!.toJson(),
        "updated_ts": updatedTs,
        "updated_by": updatedBy,
        "version": version,
      };
}

class MdChatUserMetadata {
  MdChatUserMetadata({
    this.homeCountry,
  });

  String? homeCountry;

  factory MdChatUserMetadata.fromJson(final Map<String, dynamic> json) =>
      MdChatUserMetadata(
        homeCountry: json["homeCountry"] as String?,
      );

  Map<String, dynamic> toJson() => {
        "homeCountry": homeCountry,
      };
}

class SessionToken {
  SessionToken({
    this.expiresAt,
    this.sessionToken,
  });

  int? expiresAt;
  String? sessionToken;

  factory SessionToken.fromJson(final Map<String, dynamic> json) =>
      SessionToken(
        expiresAt: json["expires_at"] as int?,
        sessionToken: json["session_token"] as String?,
      );

  Map<String, dynamic> toJson() => {
        "expires_at": expiresAt,
        "session_token": sessionToken,
      };
}

class PolicyAcceptance {
  PolicyAcceptance({
    this.policyType,
    this.language,
    this.policyDocVersion,
    this.acceptedTs,
    this.ipAddress,
    this.latest,
  });

  String? policyType;
  String? language;
  String? policyDocVersion;
  String? acceptedTs;
  String? ipAddress;
  bool? latest;

  factory PolicyAcceptance.fromJson(final Map<String, dynamic> json) =>
      PolicyAcceptance(
        policyType: json["policyType"] as String?,
        language: json["language"] as String?,
        policyDocVersion: json["policyDocVersion"] as String?,
        acceptedTs: json["acceptedTS"] as String?,
        ipAddress: json["ipAddress"] as String?,
        latest: json["latest"] as bool?,
      );

  Map<String, dynamic> toJson() => {
        "policyType": policyType,
        "language": language,
        "policyDocVersion": policyDocVersion,
        "acceptedTS": acceptedTs,
        "ipAddress": ipAddress,
        "latest": latest,
      };
}

class UserCommunit {
  UserCommunit({
    this.uuid,
    this.userId,
    this.communityId,
    this.status,
    this.userCommunityRoles,
    this.community,
    this.eligibility,
    this.businessCommunity,
    this.metadata,
  });

  String? uuid;
  String? userId;
  String? communityId;
  Status? status;
  List<UserCommunityRole>? userCommunityRoles;
  CommunitiesList? community;
  UserEligibility? eligibility;
  bool? businessCommunity;
  UserCommunityMetadata? metadata;

  factory UserCommunit.fromJson(final Map<String, dynamic> json) =>
      UserCommunit(
        uuid: json["uuid"] as String?,
        userId: json["userId"] as String?,
        communityId: json["communityId"] as String?,
        status:
            json["status"] == null ? null : statusValues.map[json["status"]],
        userCommunityRoles: json["userCommunityRoles"] == null
            ? null
            : List<UserCommunityRole>.from(json["userCommunityRoles"].map(
                    (final x) =>
                        UserCommunityRole.fromJson(x as Map<String, dynamic>))
                as Iterable<dynamic>),
        community: json["community"] == null
            ? null
            : CommunitiesList.fromJson(json["community"] as Map<String, dynamic>),
        eligibility: json["eligibility"] == null
            ? null
            : UserEligibility.fromJson(
                json["eligibility"] as Map<String, dynamic>?),
        businessCommunity: json["businessCommunity"] as bool?,
        metadata: json["metadata"] == null
            ? null
            : UserCommunityMetadata.fromJson(
                json["metadata"] as Map<String, dynamic>?),
      );

  Map<String, dynamic> toJson() => {
        "uuid": uuid,
        "userId": userId,
        "communityId": communityId,
        "status": status ?? statusValues.reverse[status],
        "userCommunityRoles": userCommunityRoles ??
            List<dynamic>.from(
                userCommunityRoles!.map((final x) => x.toJson())),
        "community": community ?? community!.toJson(),
        "eligibility": eligibility ?? eligibility!.toJson(),
        "businessCommunity": businessCommunity,
        "metadata": metadata ?? metadata!.toJson(),
      };
}

class Community {
  Community({
    this.uuid,
    this.createdTs,
    this.updatedTs,
    this.createdBy,
    this.updatedBy,
    this.version,
    this.id,
    this.accountId,
    this.name,
    this.description,
    this.sect,
    this.handle,
    this.communityType,
    this.location,
    this.webSiteUrl,
    this.links,
    this.operatingSchedule,
    this.contactPoints,
    this.facilities,
    this.status,
    this.contentVisibilityType,
    this.settings,
    this.media,
    this.eligibility,
    this.hidden,
    this.business,
    this.verified,
    this.premium,
    this.active,
    this.creationSourceType,
    this.rangeMembersCount,
    this.tags,
  });

  String? uuid;
  String? createdTs;
  String? updatedTs;
  String? createdBy;
  String? updatedBy;
  int? version;
  String? id;
  int? accountId;
  String? name;
  String? description;
  String? sect;
  String? handle;
  String? communityType;
  Location? location;
  String? webSiteUrl;
  UserLinks? links;
  OperatingSchedule? operatingSchedule;
  List<ContactPoint>? contactPoints;
  List<Facility>? facilities;
  String? status;
  String? contentVisibilityType;
  List<Setting>? settings;
  CoverMedia? media;
  UserEligibility? eligibility;
  bool? hidden;
  bool? business;
  bool? verified;
  bool? premium;
  bool? active;
  String? creationSourceType;
  int? rangeMembersCount;
  List<Tag>? tags;

  factory Community.fromJson(final Map<String, dynamic> json) => Community(
        uuid: json["uuid"] as String?,
        createdTs: json["createdTS"] as String?,
        updatedTs: json["updatedTS"] as String?,
        createdBy: json["createdBy"] as String?,
        updatedBy: json["updatedBy"] as String?,
        version: json["version"] as int?,
        id: json["id"] as String?,
        accountId: json["accountId"] as int?,
        name: json["name"] as String?,
        description: json["description"] as String?,
        sect: json["sect"] as String?,
        handle: json["handle"] as String?,
        communityType: json["communityType"] as String?,
        location: json["location"] == null
            ? null
            : Location.fromJson(json["location"] as Map<String, dynamic>),
        webSiteUrl: json["webSiteUrl"] as String?,
        links: json["links"] == null
            ? null
            : UserLinks.fromJson(json["links"] as Map<String, dynamic>),
        operatingSchedule: json["operatingSchedule"] == null
            ? null
            : OperatingSchedule.fromJson(
                json["operatingSchedule"] as Map<String, dynamic>),
        contactPoints: json["contactPoints"] == null
            ? null
            : List<ContactPoint>.from(json["contactPoints"].map((final x) =>
                    ContactPoint.fromJson(x as Map<String, dynamic>))
                as Iterable<dynamic>),
        facilities: json["facilities"] == null
            ? null
            : List<Facility>.from(json["facilities"].map(
                    (final x) => Facility.fromJson(x as Map<String, dynamic>))
                as Iterable<dynamic>),
        status: json["status"] as String?,
        contentVisibilityType: json["contentVisibilityType"] as String?,
        settings: json["settings"] == null
            ? null
            : List<Setting>.from(json["settings"].map(
                    (final x) => Setting.fromJson(x as Map<String, dynamic>))
                as Iterable<dynamic>),
        media: json["media"] == null
            ? null
            : CoverMedia.fromJson(json["media"] as Map<String, dynamic>),
        eligibility: json["eligibility"] == null
            ? null
            : UserEligibility.fromJson(
                json["eligibility"] as Map<String, dynamic>),
        hidden: json["hidden"] as bool?,
        business: json["business"] as bool?,
        verified: json["verified"] as bool?,
        premium: json["premium"] as bool?,
        active: json["active"] as bool?,
        creationSourceType: json["creationSourceType"] as String?,
        rangeMembersCount: json["rangeMembersCount"] as int?,
        tags: json["tags"] == null
            ? null
            : List<Tag>.from(json["tags"]
                    .map((final x) => Tag.fromJson(x as Map<String, dynamic>))
                as Iterable<dynamic>),
      );

  Map<String, dynamic> toJson() => {
        "uuid": uuid,
        "createdTS": createdTs,
        "updatedTS": updatedTs,
        "createdBy": createdBy,
        "updatedBy": updatedBy,
        "version": version,
        "id": id,
        "accountId": accountId,
        "name": name,
        "description": description,
        "sect": sect,
        "handle": handle,
        "communityType": communityType,
        "location": location ?? location!.toJson(),
        "webSiteUrl": webSiteUrl,
        "links": links ?? links!.toJson(),
        "operatingSchedule": operatingSchedule ?? operatingSchedule!.toJson(),
        "contactPoints": contactPoints ??
            List<dynamic>.from(contactPoints!.map((final x) => x.toJson())),
        "facilities": facilities ??
            List<dynamic>.from(facilities!.map((final x) => x.toJson())),
        "status": status,
        "contentVisibilityType": contentVisibilityType,
        "settings": settings ??
            List<dynamic>.from(settings!.map((final x) => x.toJson())),
        "media": media ?? media!.toJson(),
        "eligibility": eligibility ?? eligibility!.toJson(),
        "hidden": hidden,
        "business": business,
        "verified": verified,
        "premium": premium,
        "active": active,
        "creationSourceType": creationSourceType,
        "rangeMembersCount": rangeMembersCount,
        "tags": tags ?? List<dynamic>.from(tags!.map((final x) => x.toJson())),
      };
}

class UserEligibility {
  UserEligibility();

  factory UserEligibility.fromJson(final Map<String, dynamic>? json) =>
      UserEligibility();

  Map<String, dynamic> toJson() => {};
}

class UserLinks {
  UserLinks({
    this.invite,
  });

  String? invite;

  factory UserLinks.fromJson(final Map<String, dynamic> json) => UserLinks(
        invite: json["invite"] as String?,
      );

  Map<String, dynamic> toJson() => {
        "invite": invite,
      };
}

class OperatingSchedule {
  OperatingSchedule({
    this.weeklyOperations,
    this.daywiseOperations,
  });

  WeeklyOperations? weeklyOperations;
  dynamic daywiseOperations;

  factory OperatingSchedule.fromJson(final Map<String, dynamic> json) =>
      OperatingSchedule(
        weeklyOperations: json["weeklyOperations"] == null
            ? null
            : WeeklyOperations.fromJson(
                json["weeklyOperations"] as Map<String, dynamic>),
        daywiseOperations: json["daywiseOperations"],
      );

  Map<String, dynamic> toJson() => {
        "weeklyOperations": weeklyOperations ?? weeklyOperations!.toJson(),
        "daywiseOperations": daywiseOperations,
      };
}

class WeeklyOperations {
  WeeklyOperations({
    this.startDayOfWeek,
    this.endDayOfWeek,
    this.operatingShifts,
  });

  String? startDayOfWeek;
  String? endDayOfWeek;
  List<OperatingShift>? operatingShifts;

  factory WeeklyOperations.fromJson(final Map<String, dynamic> json) =>
      WeeklyOperations(
        startDayOfWeek: json["startDayOfWeek"] as String?,
        endDayOfWeek: json["endDayOfWeek"] as String?,
        operatingShifts: json["operatingShifts"] == null
            ? null
            : List<OperatingShift>.from(json["operatingShifts"].map((final x) =>
                    OperatingShift.fromJson(x as Map<String, dynamic>))
                as Iterable<dynamic>),
      );

  Map<String, dynamic> toJson() => {
        "startDayOfWeek": startDayOfWeek,
        "endDayOfWeek": endDayOfWeek,
        "operatingShifts": operatingShifts ??
            List<dynamic>.from(operatingShifts!.map((final x) => x.toJson())),
      };
}

class OperatingShift {
  OperatingShift({
    this.name,
    this.opens,
    this.closes,
  });

  String? name;
  String? opens;
  String? closes;

  factory OperatingShift.fromJson(final Map<String, dynamic> json) =>
      OperatingShift(
        name: json["name"] as String?,
        opens: json["opens"] as String?,
        closes: json["closes"] as String?,
      );

  Map<String, dynamic> toJson() => {
        "name": name,
        "opens": opens,
        "closes": closes,
      };
}

class UserCommunityMetadata {
  UserCommunityMetadata({
    this.mdGroupChannelUrl,
  });

  String? mdGroupChannelUrl;

  factory UserCommunityMetadata.fromJson(final Map<String, dynamic>? json) =>
      UserCommunityMetadata(
        mdGroupChannelUrl: json?["mdGroupChannelUrl"] as String?,
      );

  Map<String, dynamic> toJson() => {
        "mdGroupChannelUrl": mdGroupChannelUrl,
      };
}

enum Status { APPROVED, FOLLOWING, REMOVED }

final statusValues = EnumValues({
  "APPROVED": Status.APPROVED,
  "FOLLOWING": Status.FOLLOWING,
  "REMOVED": Status.REMOVED
});
