part of kitcod_uikit_flutter;

class BottomSheetDropdown extends StatefulWidget {
  const BottomSheetDropdown({
    required this.heading,
    required this.icon,
    required this.hintText,
    required this.postType,
    this.profileDetails,
    this.moreOptions,
    this.hintTextStyle,
    this.iconColor,
    this.iconBackgroundColor,
    this.headingStyle,
    this.descriptionStyle,
    this.nameStyle,
    this.userNameStyle,
    this.groupTagsStyle,
    final Key? key,
  }) : super(key: key);

  // -------------------------------- VARIABLES -------------------------------- //
  final UserProfile? profileDetails;
  final String heading;
  final Color? iconColor;
  final Color? iconBackgroundColor;
  final TextStyle? headingStyle;
  final TextStyle? descriptionStyle;
  final List<PostType>? postType;
  final TextStyle? nameStyle;
  final TextStyle? groupTagsStyle;
  final TextStyle? userNameStyle;
  final String hintText;
  final TextStyle? hintTextStyle;
  final IconData? icon;
  final List<MoreOptions>? moreOptions;
  @override
  State<BottomSheetDropdown> createState() => _BottomSheetDropdownState();
}

// -------------------------------- BUILD FUNCTION -------------------------------- //
class _BottomSheetDropdownState extends State<BottomSheetDropdown> {
  @override
  void initState() {
    super.initState();
  }

  @override
  void dispose() {
    super.dispose();
  }

  @override
  Wrap build(final BuildContext context) => Wrap(
        children: [
          Container(
            alignment: Alignment.center,
            child: SizedBox(
              width: MediaQuery.of(context).size.width * 0.15,
              height: 3,
              child: DecoratedBox(
                decoration: BoxDecoration(color: Colors.indigo.shade100),
              ),
            ),
          ),
          Padding(
              padding: const EdgeInsets.all(15),
              child: Text(widget.heading,
                  style: widget.headingStyle ?? const TextStyle(fontSize: 20))),
          if (widget.postType != null)
            for (var option in widget.postType!)
              if (option == PostType.announcement)
                BottomSheetNavigation(
                  profileDetails: widget.profileDetails,
                  selectedOption: option,
                  heading: "Announcement",
                  description: "Priority notifications to followers",
                  icon: KitcodAppIcons.announcement,
                  iconColor: widget.iconColor,
                  iconBackgroundColor: widget.iconBackgroundColor,
                  headingStyle: widget.headingStyle,
                  descriptionStyle: widget.descriptionStyle,
                  hintText: widget.hintText,
                  moreOptions: widget.moreOptions,
                  postType: widget.postType,
                  groupTagsStyle: widget.groupTagsStyle,
                  hintTextStyle: widget.hintTextStyle,
                  nameStyle: widget.nameStyle,
                  userNameStyle: widget.userNameStyle,
                )
              else if (option == PostType.poll)
                BottomSheetNavigation(
                  profileDetails: widget.profileDetails,
                  selectedOption: option,
                  heading: "Poll",
                  description: "Get opinion from your followers",
                  icon: KitcodAppIcons.poll,
                  iconColor: widget.iconColor,
                  iconBackgroundColor: widget.iconBackgroundColor,
                  headingStyle: widget.headingStyle,
                  descriptionStyle: widget.descriptionStyle,
                  hintText: widget.hintText,
                  moreOptions: widget.moreOptions,
                  postType: widget.postType,
                  groupTagsStyle: widget.groupTagsStyle,
                  hintTextStyle: widget.hintTextStyle,
                  nameStyle: widget.nameStyle,
                  userNameStyle: widget.userNameStyle,
                )
        ],
      );
}
