part of kitcod_uikit_flutter;

class BottomSheetNavigation extends StatelessWidget {
  const BottomSheetNavigation({
    required this.heading,
    required this.description,
    required this.icon,
    required this.hintText,
    required this.selectedOption,
    this.profileDetails,
    this.moreOptions,
    this.postType,
    this.nameStyle,
    this.userNameStyle,
    this.groupTagsStyle,
    this.hintTextStyle,
    this.iconColor,
    this.iconBackgroundColor,
    this.headingStyle,
    this.descriptionStyle,
    final Key? key,
  }) : super(key: key);

  // -------------------------------- VARIABLES -------------------------------- //
  final UserProfile? profileDetails;
  final String heading;
  final String description;
  final IconData icon;
  final String hintText;
  final TextStyle? hintTextStyle;
  final Color? iconColor;
  final Color? iconBackgroundColor;
  final TextStyle? headingStyle;
  final TextStyle? descriptionStyle;
  final List<PostType>? postType;
  final TextStyle? nameStyle;
  final TextStyle? groupTagsStyle;
  final TextStyle? userNameStyle;
  final List<MoreOptions>? moreOptions;
  final PostType selectedOption;

// -------------------------------- BUILD FUNCTION -------------------------------- //
  @override
  Widget build(final BuildContext context) => TextButton(
      onPressed: () => {
            Navigator.push(
              context,
              MaterialPageRoute(
                builder: (final context) => CreateEditPost(
                    isEdit: false,
                    profileDetails: profileDetails,
                    headerView: HeaderView(
                      backgroundColor: Colors.white.withOpacity(0.1),
                      leftSideIcon: IconButton(
                        onPressed: () {
                          Navigator.pop(context);
                        },
                        icon: const Icon(
                          Icons.arrow_back_outlined,
                          color: Colors.black,
                        ),
                      ),
                      header: const Text(
                        "Create New",
                        style: TextStyle(color: Colors.black),
                      ),
                      headerAlignment: Alignment.centerLeft,
                    ),
                    nameStyle: nameStyle,
                    userNameStyle: userNameStyle,
                    groupTagsStyle: groupTagsStyle,
                    descriptionStyle: descriptionStyle,
                    headingStyle: headingStyle,
                    iconColor: iconColor,
                    iconBackgroundColor: iconBackgroundColor,
                    postType: postType,
                    moreOptions: moreOptions,
                    selectedOption: selectedOption),
              ),
            )
          },
      child: SizedBox(
        child: BottomSheetOption(
          heading: heading,
          description: description,
          icon: icon,
          iconColor: iconColor,
          iconBackgroundColor: iconBackgroundColor,
          headingStyle: headingStyle,
          descriptionStyle: descriptionStyle,
        ),
      ));
}
