// ignore_for_file: avoid_dynamic_calls

part of kitcod_uikit_flutter;

class ProfileBottomSheet extends StatefulWidget {
  ProfileBottomSheet({
    required this.optionsHeading,
    this.profileDetails,
    this.nameStyle,
    this.userNameStyle,
    this.groupTagsStyle,
    this.postedToString,
    this.func,
    final Key? key,
  }) : super(key: key);

  // -------------------------------- VARIABLES -------------------------------- //
  final UserProfile? profileDetails;
  final Text optionsHeading;
  final String? postedToString;
  final TextStyle? nameStyle;
  final TextStyle? groupTagsStyle;
  final TextStyle? userNameStyle;
  final Function(String)? func;
  List<String> groupsInfo = [];

  @override
  State<ProfileBottomSheet> createState() => _ProfileBottomSheet();
}

class _ProfileBottomSheet extends State<ProfileBottomSheet> {
  Future? groupsBulkData;
  CommunitiesList? groupDetail;
  List<CommunitiesList> listCommunties = [];
  List body = []; // to do

  @override
  void initState() {
    // final SharedPreferences prefs = await _prefs;
    getUserObj();
/*    body = [
      {"id": "5bc447519f247b5778b024ec", "httpMethod": "Get"},
      {"id": "5ca453199f247b541d611e2a", "httpMethod": "Get"},
      {"id": "5ca5a2fb9f247b078f26e1d0", "httpMethod": "Get"},
      {"id": "5ca48a0b9f247b078f26e1cc", "httpMethod": "Get"},
      {"id": "5ca4887c9f247b078f26e1ca", "httpMethod": "Get"},
      {"id": "5ca489a79f247b078f26e1cb", "httpMethod": "Get"},
      {"id": "5cb025439f247b078f26e1e9", "httpMethod": "Get"},
      {"id": "5cca8ba29f247b6c387534d9", "httpMethod": "Get"},
      {"id": "5cce65e79f247b6c387534f3", "httpMethod": "Get"},
      {"id": "5cbea64c9f247b078f26e200", "httpMethod": "Get"},
      {"id": "5cdb4f589f247b6c38753555", "httpMethod": "Get"},
      {"id": "5cdd5a2c9f247b6c38753564", "httpMethod": "Get"},
      {"id": "5cde16c19f247b6c38753568", "httpMethod": "Get"},
      {"id": "5ce4167a9f247b6c38753591", "httpMethod": "Get"},
      {"id": "5cdbc0ce9f247b6c38753557", "httpMethod": "Get"},
      {"id": "5cfcde0a9f247b7262075679", "httpMethod": "Get"},
      {"id": "5cfdf9119f247b726207567a", "httpMethod": "Get"},
      {"id": "5d5e1acb9f247b5f884aa347", "httpMethod": "Get"},
      {"id": "5de51dcc31cbd60447ff79d6", "httpMethod": "Get"},
      {"id": "5d47ca199f247b5f884aa33b", "httpMethod": "Get"},
      {"id": "5e91e9d8b26c32236fe88f92", "httpMethod": "Get"},
      {"id": "5ca55cd89f247b078f26e1cf", "httpMethod": "Get"},
      {"id": "5f0d7e11feec1a54f7d20662", "httpMethod": "Get"},
      {"id": "5f433347eb0ae97050d94d13", "httpMethod": "Get"},
      {"id": "5f450375eb0ae97050d94d36", "httpMethod": "Get"},
      {"id": "5f240f4a9bbf453c4e156844", "httpMethod": "Get"},
      {"id": "601ee39aac77e1646a92b6f1", "httpMethod": "Get"},
      {"id": "6065a072e8024d60f9383e33", "httpMethod": "Get"},
      {"id": "5ccce44b9f247b6c387534ec", "httpMethod": "Get"},
      {"id": "6095639036ed6c6a067f1b3c", "httpMethod": "Get"},
      {"id": "62a865b1aaa21d558bf4e78d", "httpMethod": "Get"},
      {"id": "62a865dbaaa21d558bf4e78f", "httpMethod": "Get"}
    ];
    // To do
    groupsBulkData = KitcodApi.instance.getCommunitiesBulkAWSData(body);
    adminGroups = KitcodApi.instance.getAdminUserGroupsFromProfileData();*/
    super.initState();
    // adminGroups.then((final value) => widget.groupsInfo = value);
  }

  /* Future<UserProfile?> getUserObj() async {
    final SharedPreferences prefs = await SharedPreferences.getInstance();
    if (prefs.getString("userProfileData") != null) {
      final String userPref = prefs.getString("userProfileData")!;
      final Map<String, dynamic> userProfileData =
          jsonDecode(userPref) as Map<String, dynamic>;
      final UserProfile userProfile = UserProfile.fromJson(userProfileData);
      return userProfile;
    }
    return null;
  }*/
  Future<void> getUserObj() async {
    final SharedPreferences prefs = await SharedPreferences.getInstance();
    if (prefs.getString("userProfileData") != null) {
      final String userPref = prefs.getString("userProfileData")!;
      final Map<String, dynamic> userProfileData =
          jsonDecode(userPref) as Map<String, dynamic>;
      final UserProfile userProfile = UserProfile.fromJson(userProfileData);
      for (final UserCommunit community in userProfile.userCommunities!) {
        if (community.userCommunityRoles != null) {
          if (community.userCommunityRoles![0].role == "ADMINISTRATOR") {
            listCommunties.add(community.community!);
          }
        }
      }

      Map<String, String> userCommunities;
      if (userProfile.userCommunities!.isNotEmpty) {
        for (final UserCommunit item in userProfile.userCommunities!) {
          final jsonO = {
            "id": item.communityId,
            "httpMethod": "Get",
          };
          body.add(jsonO);
        }
      } else {}
    }
    setState(() {
      if (body.isNotEmpty) {
        groupsBulkData = KitcodApi.instance.getCommunitiesBulkAWSData(body);
      }
    });
  }

  @override
  void dispose() {
    super.dispose();
  }

// -------------------------------- BUILD FUNCTION -------------------------------- //
  @override
  TextButton build(final BuildContext context1) => TextButton(
        onPressed: () => showModalBottomSheet(
            shape: const RoundedRectangleBorder(
                borderRadius: BorderRadius.vertical(
              top: Radius.circular(20),
            )),
            isScrollControlled: true,
            context: context1,
            builder: (final context) => Container(
                padding: const EdgeInsets.all(8),
                child: Wrap(
                  children: [
                    Container(
                      alignment: Alignment.center,
                      child: SizedBox(
                        width: MediaQuery.of(context).size.width * 0.15,
                        height: 3,
                        child: DecoratedBox(
                          decoration:
                              BoxDecoration(color: Colors.indigo.shade100),
                        ),
                      ),
                    ),
                    Padding(
                        padding: const EdgeInsets.all(15),
                        child: widget.optionsHeading),
                    FutureBuilder(
                        future: groupsBulkData,
                        // ignore: avoid_types_on_closure_parameters
                        builder: (final context, final snapshot) {
                          if (!snapshot.hasData) {
                            return const CircularProgressIndicator();
                          } else {
                            if (snapshot.hasError) {
                              return Center(
                                  child: Text("Error: ${snapshot.error}"));
                            } else {
                              /* final List<Communities> communitiesList =
                                  snapshot.data! as List<Communities>;*/
                              if (listCommunties == null ||
                                  listCommunties.isEmpty) {
                                return const Text(
                                  "No Group found",
                                  style: TextStyle(color: Colors.black),
                                );
                              } else {
                                return ListView.builder(
                                  shrinkWrap: true,
                                  itemCount: listCommunties.length,
                                  itemBuilder: (final context, final index) {
                                    /* if (widget.groupsInfo
                                      .contains(communitiesList[index].id)) {*/
                                    if (listCommunties[index].id!.isNotEmpty) {
                                      return GestureDetector(
                                        onTap: () => setState(() {
                                          Navigator.of(context1).pop();
                                          groupDetail = listCommunties[index];
                                          widget.func!(
                                              listCommunties[index].id!);
                                        }),

                                        /* ScaffoldMessenger.of(context).showSnackBar(
                                          const SnackBar(
                                            content:Text("BEIM LADEN DER POST-DATEN IST EIN FEHLER AUFGETRETEN!"),
                                            duration: Duration(seconds: 2),
                                          ),
                                        ),*/
                                        child: GroupDetails(
                                          groupImageUrl: listCommunties[index]
                                                      .media!
                                                      .proImg ==
                                                  null
                                              ? "https://picsum.photos/201"
                                              : listCommunties[index]
                                                  .media!
                                                  .proImg!
                                                  .resizedMediaList!
                                                  .first
                                                  .mediaUrl!,
                                          groupTitle:
                                              listCommunties[index].name!,
                                          members: listCommunties[index]
                                                      .rangeMembersCount ==
                                                  null
                                              ? ""
                                              : listCommunties[index]
                                                  .rangeMembersCount
                                                  .toString(),
                                        ),
                                      );
                                    } else {
                                      return Container();
                                    }
                                  },
                                );
                              }
                            }
                          }
                        })
                  ],
                ))),
        child: SizedBox(
          height: MediaQuery.of(context).size.height * 0.11,
          width: MediaQuery.of(context).size.width,
          child: ProfileDetails(
            name:
                "${widget.profileDetails!.firstName} ${widget.profileDetails!.lastName}",
            profileImageUrl: widget.profileDetails!.media!.proImg == null
                ? "https://picsum.photos/200"
                : widget.profileDetails!.media!.proImg!.resizedMediaList![0]
                    .mediaUrl,
            nameStyle: widget.nameStyle,
            userNameStyle: widget.userNameStyle,
            groupTagsStyle: widget.groupTagsStyle,
            groupDetailUpdated: groupDetail,
          ),
        ),
      );
}
