part of kitcod_uikit_flutter;

class CommentDetails extends StatelessWidget {
  const CommentDetails({
    required this.commentapi,
    required this.buildContext,
    this.nameStyle,
    this.commentStyle,
    this.postedTimeStyle,
    this.submitButtonColor,
    final Key? key,
  }) : super(key: key);

  // -------------------------------- VARIABLES -------------------------------- //

  final CommentList commentapi;
  final BuildContext buildContext;
  final TextStyle? nameStyle;
  final TextStyle? commentStyle;
  final TextStyle? postedTimeStyle;
  final Color? submitButtonColor;

  // -------------------------------- BUILD FUNCTION -------------------------------- //

  @override
  Column build(final BuildContext context) => Column(
        children: [
          TextButton(
            onPressed: () {
              Navigator.push(
                buildContext,
                MaterialPageRoute(
                  builder: (final context) => UserProfileView(
                    headerView: HeaderView(
                      backgroundColor: Colors.indigoAccent.withOpacity(0.1),
                      leftSideIcon: IconButton(
                        onPressed: () {
                          Navigator.pop(context);
                        },
                        icon: const Icon(
                          Icons.arrow_back_outlined,
                          color: Colors.black,
                        ),
                      ),
                      header: const Text(
                        "Profile Overview",
                        style: TextStyle(color: Colors.black),
                      ),
                      headerAlignment: Alignment.centerLeft,
                    ),
                    nameStyle: const TextStyle(
                      fontSize: 20,
                      fontWeight: FontWeight.bold,
                    ),
                    button: Button(
                      name: "Follow",
                      onPressed: () {},
                      backgroundColor: Colors.indigoAccent,
                      textStyle: const TextStyle(color: Colors.white),
                      height: 40,
                    ),
                    profileDetailsNameStyle:
                        TextStyle(color: Colors.grey.shade600),
                    profileDetailsValueStyle:
                        const TextStyle(fontWeight: FontWeight.bold),
                    groupCardButtonColor: Colors.indigoAccent,
                    groupCardButtonStyle: const TextStyle(color: Colors.white),
                    groupCardMembersStyle:
                        const TextStyle(color: Colors.grey, fontSize: 12),
                    groupCardTitleStyle: const TextStyle(
                        fontSize: 17,
                        fontWeight: FontWeight.bold,
                        color: Colors.black),
                    groupPageAboutStyle:
                        const TextStyle(fontSize: 15, color: Colors.grey),
                    groupPageMembersStyle: const TextStyle(
                        fontSize: 17,
                        fontWeight: FontWeight.bold,
                        color: Colors.black),
                    groupPageStatusStyle:
                        const TextStyle(fontSize: 17, color: Colors.grey),
                    groupPageTitleStyle: const TextStyle(
                      fontSize: 30,
                      fontWeight: FontWeight.bold,
                      color: Colors.black,
                    ),
                    avatarSize: 12,
                    postPostedTimeStyle: const TextStyle(
                      fontSize: 15,
                      color: Colors.grey,
                    ),
                    postFeedTitleStyle: const TextStyle(
                        fontSize: 15,
                        color: Colors.black,
                        fontWeight: FontWeight.bold),
                    postFeedDescriptionStyle:
                        const TextStyle(fontSize: 15, color: Colors.black),
                    postFeedAudioTitleStyle: const TextStyle(
                        fontSize: 17,
                        fontWeight: FontWeight.bold,
                        color: Colors.black),
                    postNameStyle: const TextStyle(
                        fontSize: 15,
                        fontWeight: FontWeight.bold,
                        color: Colors.black),
                    postUserNameStyle: const TextStyle(
                        fontSize: 15,
                        color: Colors.black,
                        fontWeight: FontWeight.normal),
                    postGroupTagsStyle: const TextStyle(color: Colors.indigo),
                  ),
                ),
              );
            },
            child: const ProfileDetails(
              profileImageUrl: "https://picsum.photos/200",
              // name: comment.name,
              // userName: comment.username,
              // profileImageUrl: comment.profileImageUrl,
            ),
          ),
          SizedBox(
            width: MediaQuery.of(buildContext).size.width,
            child: Padding(
              padding: const EdgeInsets.only(left: 55),
              child: Column(
                crossAxisAlignment: CrossAxisAlignment.start,
                children: [
                  Text(timeAgo(commentapi.createdTs!),
                      style: const TextStyle(
                        fontSize: 15,
                        color: Colors.grey,
                      )),
                  const SizedBox(
                    height: 10,
                  ),
                  Text(commentapi.html!,
                      style:
                          const TextStyle(fontSize: 15, color: Colors.black)),
                  const SizedBox(
                    height: 10,
                  ),
                  const Text("Reply", style: TextStyle(color: Colors.blue)),
                  const SizedBox(
                    height: 10,
                  ),
                ],
              ),
            ),
          ),

          // Column(
          //   crossAxisAlignment: CrossAxisAlignment.start,
          //   children: [
          //     Text(timeAgo(commentapi.createdTs!),
          //         style: const TextStyle(
          //           fontSize: 15,
          //           color: Colors.grey,
          //         )),
          //     Text(commentapi.html!,
          //         style: const TextStyle(fontSize: 15, color: Colors.black)),
          //     const Text("Reply", style: TextStyle(color: Colors.blue)),
          //     // if (comment.replies != null)
          //     //   for (var i = 1; i < comment.replies!.length && i <= 3; i++)
          //     //     CommentDetails(
          //     //         comment: comment.replies![i].comment!,
          //     //         name: comment.replies![i].name!,
          //     //         profileImageUrl: comment.replies![i].profileImageUrl!,
          //     //         postedTime: comment.postedTime,
          //     //         commentStyle: commentStyle,
          //     //         nameStyle: nameStyle,
          //     //         postedTimeStyle: postedTimeStyle),
          //   ],
          // ),
          SizedBox(
            width: MediaQuery.of(buildContext).size.width,
            height: 3,
            child: DecoratedBox(
              decoration: BoxDecoration(color: Colors.indigo.shade50),
            ),
          ),
        ],
      );

  String timeAgo(final String date) {
    final dt = DateTime.parse(date);
    return "${timeago.format(dt, locale: "en_short")} ago";
  }
}
