// part of kitcod_uikit_flutter;

// class ImagePickerWidget extends StatelessWidget {
//   const ImagePickerWidget({final Key? key}) : super(key: key);

//   @override
//   Widget build(final BuildContext context) => const MaterialApp(
//         title: "Image Picker Demo",
//         home: MyHomePage(title: "Image Picker Example"),
//       );
// }

// class MyHomePage extends StatefulWidget {
//   const MyHomePage({final Key? key, this.title}) : super(key: key);

//   final String? title;

//   @override
//   State<MyHomePage> createState() => _MyHomePageState();
// }

// class _MyHomePageState extends State<MyHomePage> {
//   List<XFile>? _imageFileList;

//   void _setImageFileListFromFile(final XFile? value) {
//     _imageFileList = value == null ? null : <XFile>[value];
//   }

//   dynamic _pickImageError;
//   bool isVideo = false;

//   VideoPlayerController? _controller;
//   VideoPlayerController? _toBeDisposed;
//   String? _retrieveDataError;

//   final ImagePicker _picker = ImagePicker();
//   final TextEditingController maxWidthController = TextEditingController();
//   final TextEditingController maxHeightController = TextEditingController();
//   final TextEditingController qualityController = TextEditingController();

//   Future<void> uploadSingleImage() async {
//     const String bucketName = "test";
//     const String cognitoPoolId = "ap-southeast-1_kU1Ppc2tj";
//     const String bucketRegion = "ap-southeast-1";
//     const String bucketSubRegion = "Sub region of bucket";

//     const String fileUploadFolder =
//         "folder inside bucket where we want file to be uploaded";

//     const String filePath = "";
//     final ImageData imageData = ImageData("uniqueFileName", filePath,
//         uniqueId: "uniqueIdToTrackImage", imageUploadFolder: fileUploadFolder);

//     final String? result = await AmazonS3Cognito.upload(
//         bucketName, cognitoPoolId, bucketRegion, bucketSubRegion, imageData,
//         needMultipartUpload: true);
//     //print(result);
//   }

//   Future<void> _onImageButtonPressed(final ImageSource source,
//       {final BuildContext? context, final bool isMultiImage = false}) async {
//     await _displayPickImageDialog(context!,
//         (final maxWidth, final maxHeight, final quality) async {
//       try {
//         final XFile? pickedFile = await _picker.pickImage(
//           source: source,
//           maxWidth: maxWidth,
//           maxHeight: maxHeight,
//           imageQuality: quality,
//         );
//         setState(() {
//           _setImageFileListFromFile(pickedFile);
//         });
//       } catch (e) {
//         setState(() {
//           _pickImageError = e;
//         });
//       }
//     });
//   }

//   @override
//   void deactivate() {
//     super.deactivate();
//   }

//   @override
//   void dispose() {
//     super.dispose();
//   }

//   Widget _previewImages() {
//     final Text? retrieveError = _getRetrieveErrorWidget();
//     if (retrieveError != null) {
//       return retrieveError;
//     }
//     if (_imageFileList != null) {
//       return Semantics(
//         label: "image_picker_example_picked_images",
//         child: ListView.builder(
//           key: UniqueKey(),
//           itemBuilder: (final context, final index) => Semantics(
//             label: "image_picker_example_picked_image",
//             child: kIsWeb
//                 ? Image.network(_imageFileList![index].path)
//                 : Image.file(File(_imageFileList![index].path)),
//           ),
//           itemCount: _imageFileList!.length,
//         ),
//       );
//     } else if (_pickImageError != null) {
//       return Text(
//         "Pick image error: $_pickImageError",
//         textAlign: TextAlign.center,
//       );
//     } else {
//       return const Text(
//         "You have not yet picked an image.",
//         textAlign: TextAlign.center,
//       );
//     }
//   }

//   Widget _handlePreview() => _previewImages();

//   Future<void> retrieveLostData() async {
//     final LostDataResponse response = await _picker.retrieveLostData();
//     if (response.isEmpty) {
//       return;
//     }
//     if (response.file != null) {
//       setState(() {
//         if (response.files == null) {
//           _setImageFileListFromFile(response.file);
//         } else {
//           _imageFileList = response.files;
//         }
//       });
//     } else {
//       _retrieveDataError = response.exception!.code;
//     }
//   }

//   @override
//   Widget build(final BuildContext context) => Scaffold(
//         appBar: AppBar(
//           title: Text(widget.title!),
//         ),
//         body: Center(
//           child: !kIsWeb && defaultTargetPlatform == TargetPlatform.android
//               ? FutureBuilder<void>(
//                   future: retrieveLostData(),
//                   builder: (final context, final snapshot) {
//                     switch (snapshot.connectionState) {
//                       case ConnectionState.none:
//                       case ConnectionState.waiting:
//                         return const Text(
//                           "You have not yet picked an image.",
//                           textAlign: TextAlign.center,
//                         );
//                       case ConnectionState.done:
//                         return _handlePreview();
//                       default:
//                         if (snapshot.hasError) {
//                           return Text(
//                             "Pick image/video error: ${snapshot.error}}",
//                             textAlign: TextAlign.center,
//                           );
//                         } else {
//                           return const Text(
//                             "You have not yet picked an image.",
//                             textAlign: TextAlign.center,
//                           );
//                         }
//                     }
//                   },
//                 )
//               : _handlePreview(),
//         ),
//         floatingActionButton: Column(
//           mainAxisAlignment: MainAxisAlignment.end,
//           children: <Widget>[
//             Semantics(
//               label: "image_picker_example_from_gallery",
//               child: FloatingActionButton(
//                 onPressed: () {
//                   isVideo = false;
//                   _onImageButtonPressed(ImageSource.gallery, context: context);
//                 },
//                 heroTag: "image0",
//                 tooltip: "Pick Image from gallery",
//                 child: const Icon(Icons.photo),
//               ),
//             ),
//           ],
//         ),
//       );

//   Text? _getRetrieveErrorWidget() {
//     if (_retrieveDataError != null) {
//       final Text result = Text(_retrieveDataError!);
//       _retrieveDataError = null;
//       return result;
//     }
//     return null;
//   }

//   Future<void> _displayPickImageDialog(
//           final BuildContext context, final OnPickImageCallback onPick) async =>
//       showDialog(
//           context: context,
//           builder: (final context) => AlertDialog(
//                 title: const Text("Pick Image from gallery"),
//                 actions: <Widget>[
//                   TextButton(
//                     child: const Text("CANCEL"),
//                     onPressed: () {
//                       Navigator.of(context).pop();
//                     },
//                   ),
//                   TextButton(
//                       child: const Text("PICK"),
//                       onPressed: () {
//                         final double? width = maxWidthController.text.isNotEmpty
//                             ? double.parse(maxWidthController.text)
//                             : null;
//                         final double? height =
//                             maxHeightController.text.isNotEmpty
//                                 ? double.parse(maxHeightController.text)
//                                 : null;
//                         final int? quality = qualityController.text.isNotEmpty
//                             ? int.parse(qualityController.text)
//                             : null;
//                         onPick(width, height, quality);
//                         Navigator.of(context).pop();
//                       }),
//                 ],
//               ));
// }

// typedef OnPickImageCallback = void Function(
//     double? maxWidth, double? maxHeight, int? quality);
