part of kitcod_uikit_flutter;

class PollsView extends StatefulWidget {
  const PollsView(
      {this.pollDetails,
      this.interactionDetails,
      this.currentPost,
      this.currentUser,
      this.notifyParent,
      final Key? key})
      : super(key: key);

  // -------------------------------- VARIABLES -------------------------------- //
  final Poll? pollDetails;
  final InteractionSummary? interactionDetails;
  final String? currentUser;
  final String? currentPost;
  final Function(String body)? notifyParent;

  @override
  _PollsViewState createState() => _PollsViewState();
}

class _PollsViewState extends State<PollsView> {
  double option1 = 1;
  double option2 = 2;
  double option3 = 3;
  double option4 = 4;
  double option5 = 5;
  double option6 = 6;
  double option7 = 7;
  double option8 = 8;
  final Map<String, int> usersWhoVoted = {};
  String creator = "admin@gmail.com";
  bool pollSelected = false;
  int totalVotes = 0;
  List<PollsOptions> pollsOptions = [];

  @override
  void initState() {
    super.initState();
    if (widget.interactionDetails != null) {
      if (widget.interactionDetails!.userInteractions != null) {
        for (final item in widget.interactionDetails!.userInteractions!) {
          if (item.resourceSubType != null) {
            if ( // ignore: unrelated_type_equality_checks
                item.resourceSubType! == PostType.poll) {
              usersWhoVoted[item.userId!] = int.parse(item.interactionType!
                  .substring(item.interactionType!.length - 1));
            }
          }
        }
      }
    }
    for (final Option poll in widget.pollDetails!.options!) {
      pollsOptions.add(PollsOptions(
          option: poll.text,
          value: widget.interactionDetails != null
              ? widget.interactionDetails!.interactionCounts != null
                  ? widget.interactionDetails!.interactionCounts![poll.type] !=
                          null
                      ? widget
                          .interactionDetails!.interactionCounts![poll.type]!
                          .toDouble()
                      : 0.0
                  : 0.0
              : 0.0));
    }
  }

  Future<void> addPollsOption(final int choice) async {
    final addedOption = await KitcodApi.instance.addPostPollOptionAws(
        widget.currentPost!, widget.currentUser!, "POLLOPTION$choice");
    if (addedOption != null) {
      widget.notifyParent!(addedOption);
    }
  }

  @override
  void dispose() {
    super.dispose();
  }

  // -------------------------------- BUILD FUNCTION -------------------------------- //
  @override
  SizedBox build(final BuildContext context) => SizedBox(
        child: Column(
          mainAxisAlignment: MainAxisAlignment.center,
          children: [
            Polls(
              children: [
                for (PollsOptions poll in pollsOptions)
                  Polls.options(title: poll.option!, value: poll.value!)
              ],
              currentUser: widget.currentUser,
              creatorID: creator,
              pollVoteData: widget.interactionDetails != null
                  ? widget.interactionDetails!.userInteractions
                  : null,
              voteData: usersWhoVoted,
              userChoice: usersWhoVoted[widget.currentUser],
              onVoteBackgroundColor: Colors.indigo.shade100,
              lowestBackgroundColor: Colors.red.shade100,
              pollStyle: const TextStyle(color: Colors.grey),
              outlineColor: Colors.grey,
              lowestPollStyle: const TextStyle(color: Colors.red),
              onVotePollStyle: const TextStyle(color: Colors.blue),
              onVote: (final choice) {
                setState(() {
                  addPollsOption(choice);
                  usersWhoVoted[widget.currentUser!] = choice;
                });
                if (choice == 1) {
                  setState(() {
                    pollsOptions[choice - 1].value =
                        pollsOptions[choice - 1].value! + 1.0;
                  });
                }
                if (choice == 2) {
                  setState(() {
                    pollsOptions[choice - 1].value =
                        pollsOptions[choice - 1].value! + 1.0;
                  });
                }
                if (choice == 3) {
                  setState(() {
                    pollsOptions[choice - 1].value =
                        pollsOptions[choice - 1].value! + 1.0;
                  });
                }
                if (choice == 4) {
                  setState(() {
                    pollsOptions[choice - 1].value =
                        pollsOptions[choice - 1].value! + 1.0;
                  });
                }
                if (choice == 5) {
                  setState(() {
                    pollsOptions[choice - 1].value =
                        pollsOptions[choice - 1].value! + 1.0;
                  });
                }
                if (choice == 6) {
                  setState(() {
                    pollsOptions[choice - 1].value =
                        pollsOptions[choice - 1].value! + 1.0;
                  });
                }
                if (choice == 7) {
                  setState(() {
                    pollsOptions[choice - 1].value =
                        pollsOptions[choice - 1].value! + 1.0;
                  });
                }
                if (choice == 8) {
                  setState(() {
                    pollsOptions[choice - 1].value =
                        pollsOptions[choice - 1].value! + 1.0;
                  });
                }
              },
            ),
          ],
        ),
      );
}
