// ignore_for_file: use_if_null_to_convert_nulls_to_bools, avoid_dynamic_calls
part of kitcod_uikit_flutter;

class ShareStatsIcons extends StatefulWidget {
  ShareStatsIcons({
    this.resourceId,
    this.userId,
    this.isLiked,
    this.interaction,
    this.likes,
    this.comments,
    this.views,
    this.notifyParentPost,
    final Key? key,
  }) : super(key: key);

  // -------------------------------- VARIABLES -------------------------------- //

  num? likes;
  final num? comments;
  final num? views;
  bool? isLiked;
  UserInteraction? interaction;
  final String? resourceId;
  final String? userId;
  final Function(bool isliked, num likes)? notifyParentPost;

  @override
  _ShareStatsIconsState createState() => _ShareStatsIconsState();
}

// -------------------------------- BUILD FUNCTION -------------------------------- //
class _ShareStatsIconsState extends State<ShareStatsIcons> {
  List<UserInteractionsCheck> deletedInteractionsList = [];

  @override
  void initState() {
    super.initState();
  }

  @override
  void dispose() {
    super.dispose();
  }

  Future<void> changeLikeStatus() async {
    if (!widget.isLiked!) {
      widget.notifyParentPost!(
          true, widget.likes != null ? widget.likes! + 1 : 1);
      final body = await KitcodApi.instance
          .addPostLikesAws(widget.resourceId!, widget.userId!);
      if (body != null) {
        final map = jsonDecode(body);
        deletedInteractionsList.add(UserInteractionsCheck(
            userId: map["userId"].toString(),
            interactionID: map["id"].toString()));
        setState(() {
          widget.isLiked = true;
          widget.likes = widget.likes != null ? widget.likes! + 1 : 1;
          widget.notifyParentPost!(widget.isLiked!, widget.likes!-1);
        });
      }
    } else {
      bool isPresent = false;
      UserInteractionsCheck? checkItem;
      if (deletedInteractionsList.isNotEmpty) {
        checkItem = deletedInteractionsList
            .firstWhere((final element) => element.userId == widget.userId);
        isPresent = true;
      }
      widget.notifyParentPost!(
          false, widget.likes! - 1);
      final check = await KitcodApi.instance.deleteInteractionAws(
          isPresent ? checkItem!.interactionID! : widget.interaction!.id!);
      if (check) {
        setState(() {
          if (isPresent) {
            deletedInteractionsList.removeWhere(
                (final element) => element.userId == widget.userId);
          }
          widget.isLiked = false;
          widget.likes = widget.likes!;
          widget.notifyParentPost!(widget.isLiked!, widget.likes!);
        });
      }
    }
  }

  @override
  Row build(final context) => Row(
        mainAxisAlignment: MainAxisAlignment.spaceEvenly,
        children: [
          TextButton(
            onPressed: changeLikeStatus,
            child: statsIcon(
                Icon(KitcodAppIcons.like,
                    color: widget.isLiked != null && widget.isLiked == true
                        ? Colors.red
                        : Colors.black,
                    size: 20),
                widget.likes == null || widget.likes == 0
                    ? ""
                    : " ${widget.likes.toString()}"),
          ),
          statsIcon(
              const Icon(KitcodAppIcons.comment, size: 22, color: Colors.black),
              widget.comments == null || widget.likes == 0
                  ? ""
                  : widget.comments.toString()),
          statsIcon(
              const Icon(KitcodAppIcons.view, color: Colors.black, size: 18),
              widget.views == null || widget.likes == 0
                  ? ""
                  : " ${widget.views.toString()}"),
        ],
      );

  // -------------------------------- UI FUNCTION -------------------------------- //

  Row statsIcon(final Icon icon, final String? statNumber) => Row(
        children: [
          icon,
          Padding(
            padding: const EdgeInsets.only(left: 8),
            child: Text(statNumber.toString(),
                style: const TextStyle(color: Colors.black)),
          )
        ],
      );

// TextButton statsIconShare(final Icon icon, final String? statNumber) =>
//     TextButton(
//         onPressed: share,
//         child: Row(
//           children: [
//             icon,
//             Padding(
//               padding: const EdgeInsets.only(left: 8),
//               child: Text(statNumber.toString(),
//                   style: const TextStyle(color: Colors.black)),
//             )
//           ],
//         ));
}
