part of kitcod_uikit_flutter;

class TextBar extends StatefulWidget {
  const TextBar({
    required this.hintText,
    this.resourceId,
    this.userId,
    this.communityId,
    this.notifyParent,
    this.parentid,
    final Key? key,
  }) : super(key: key);
  // -------------------------------- VARIABLES -------------------------------- //

  final String hintText;
  final String? resourceId;
  final String? userId;
  final String? communityId;
  final String? parentid;
  final Function(String body)? notifyParent;

  @override
  State<TextBar> createState() => _TextBarState();
}

// -------------------------------- BUILD FUNCTION -------------------------------- //
class _TextBarState extends State<TextBar> {
  final TextEditingController commentController = TextEditingController();

  Future<void> getCommentAddedResponse() async {
    final response = await KitcodApi.instance.addCommentsOnPostAws(
      commentController.text,
      widget.resourceId!,
      widget.userId!,
      widget.communityId!,
      widget.parentid,
    );
    if (response != null) {
      widget.notifyParent!(response);
    }
  }

  @override
  Padding build(final BuildContext context) => Padding(
        padding: const EdgeInsets.fromLTRB(10, 5, 0, 10),
        child: Row(
          children: [
            Expanded(
              child: TextField(
                controller: commentController,
                decoration: InputDecoration(
                    enabledBorder: OutlineInputBorder(
                      borderSide: BorderSide(color: Colors.indigo.shade100),
                      borderRadius: BorderRadius.circular(30),
                    ),
                    focusedBorder: OutlineInputBorder(
                      borderSide: BorderSide(color: Colors.indigo.shade100),
                      borderRadius: BorderRadius.circular(30),
                    ),
                    hintText: widget.hintText,
                    // suffixIcon: const Icon(Icons.camera_alt_outlined),
                    contentPadding: const EdgeInsets.only(left: 20)),
              ),
            ),
            TextButton(
              onPressed: () {
                setState(() {
                  getCommentAddedResponse();
                  FocusScope.of(context).requestFocus(FocusNode());
                  commentController.clear();
                });
              },
              style: ButtonStyle(
                shape: MaterialStateProperty.all<RoundedRectangleBorder>(
                  RoundedRectangleBorder(
                    borderRadius: BorderRadius.circular(18),
                  ),
                ),
              ),
              child: const Icon(
                Icons.arrow_circle_right,
                size: 45,
              ),
            )
          ],
        ),
      );
}
