part of kitcod_uikit_flutter;

class CreateEditPost extends StatefulWidget {
  CreateEditPost({
    required this.headerView,
    required this.isEdit,
    this.profileDetails,
    this.feedPostApi,
    this.moreOptions,
    this.selectedOption,
    this.postType,
    this.iconColor,
    this.iconBackgroundColor,
    this.headingStyle,
    this.descriptionStyle,
    this.nameStyle,
    this.userNameStyle,
    this.groupTagsStyle,
    final Key? key,
  }) : super(key: key);

  // -------------------------------- VARIABLES -------------------------------- //

  final UserProfile? profileDetails;
  final PostList? feedPostApi;
  final HeaderView headerView;
  final bool isEdit;
  final List<PostType>? postType;
  final List<MoreOptions>? moreOptions;
  final TextStyle? nameStyle;
  final TextStyle? groupTagsStyle;
  final TextStyle? userNameStyle;
  final TextStyle? headingStyle;
  final TextStyle? descriptionStyle;
  final Color? iconColor;
  final Color? iconBackgroundColor;
  final PostType? selectedOption;
  int currentDaysValue = 0;
  int currentHoursValue = 0;
  int currentMinutesValue = 0;

  @override
  State<CreateEditPost> createState() => _CreateEditPostState();
}

class _CreateEditPostState extends State<CreateEditPost> {
  // -------------------------------- VARIABLES -------------------------------- //
  String initialTitle = "";
  List<Widget> list = [];
  List<TextEditingController> optionslist = [];
  final List<TextEditingController> controllers = [];
  final TextEditingController headlineController = TextEditingController();
  final TextEditingController storyController = TextEditingController();
  String? communityId;
  final List<CroppedFile> _imageFileList = [];
  bool _isPostLoading = false;
  List<Map<String, dynamic>> uploadData = [];
   int _currentIndex = 1;
   double _progress = 0;
   bool _isUploading = false;

  // -------------------------------- LIFECYCLE FUNCTION -------------------------------- //

  @override
  void initState() {
    super.initState();
    getSharedPrefs();
    if (widget.feedPostApi != null) {
      headlineController.text = widget.feedPostApi!.title!;
      // if (widget.selectedOption == PostType.announcement) {
      if (widget.feedPostApi!.contentMarkdown != null) {
        storyController.text = widget.feedPostApi!.contentMarkdown!;
      } else if (widget.feedPostApi!.contentHtml != null) {
        storyController.text = widget.feedPostApi!.contentHtml!;
      }
      // }
    }
    if (widget.isEdit && widget.selectedOption == PostType.poll) {
      for (final option in widget.feedPostApi!.poll!.options!) {
        final TextEditingController controller =
            TextEditingController(text: option.text);
        controllers.add(controller);
        list.add(_pollOption(context, controller));
        optionslist.add(controller);
      }

      final DateTime endDateTime =
          DateTime.parse(widget.feedPostApi!.poll!.endDateTime!);
      final DateTime publishedDateTime =
          DateTime.parse(widget.feedPostApi!.publishedTs!);
      widget.currentDaysValue =
          endDateTime.difference(publishedDateTime).inDays;
      widget.currentHoursValue =
          endDateTime.difference(publishedDateTime).inHours % 24;
      widget.currentMinutesValue =
          endDateTime.difference(publishedDateTime).inMinutes % 24;
    } else if (!widget.isEdit && widget.selectedOption == PostType.poll) {
      final TextEditingController firstChoiceController =
          TextEditingController();
      list.add(_pollOption(context, firstChoiceController));
      optionslist.add(firstChoiceController);
    }
  }

  Future<void> getSharedPrefs() async {
    final SharedPreferences prefs = await SharedPreferences.getInstance();
    communityId = prefs.getString(ApiConfig.kcDefaultCommunityId);
  }

  @override
  void dispose() {
    super.dispose();
  }

  void addObject(
      final String contentType,
      final int displayRank,
      final String resourceType,
      final String? resourceId,
      final String keyName) {
    final Map<String, dynamic> newObject = {
      "contentType": contentType,
      "displayRank": displayRank,
      "resourceType": resourceType,
      "resourceId": resourceId,
      "keyName": keyName,
      "type": "CommunityPic"
    };
    uploadData.add(newObject);
  }

  // ignore: always_declare_return_types
  pollChoice() {
    final TextEditingController controller = TextEditingController();
    controllers.add(controller);
    list.add(_pollOption(context, controller));
    optionslist.add(controller);
  }

  Future<void> addEditPostToFeed(
      final String title,
      final String contentHTML,
      final String contentMarkdown,
      final String communityId,
      final String postType,
      final String communityType,
      final List<TextEditingController>? widgetList,
      final DateTime? endingDate,
      // ignore: avoid_positional_boolean_parameters
      final bool isPoll) async {
    if (!widget.isEdit) {
      final response = await KitcodApi.instance.addPostOnFeedAws(
          title,
          contentHTML,
          contentMarkdown,
          communityId,
          postType,
          communityType,
          widgetList,
          endingDate,
          isPoll);

      if (response != null) {
        final PostList post =
            PostList.fromJson(jsonDecode(response!) as Map<String, dynamic>);

/*
        for (int i = 0; i < _imageFileList.length; i++) {
          final file = io.File(_imageFileList[i].path);
          final path = file.path;
          final dir = path.substring(0, path.lastIndexOf("/") + 1);
          final newPath = "${dir}mehdimage.jpg";
          final newFile = io.File(newPath);
          await file.rename(newFile.path).then((final renamedFile) {
            Logger.info("File renamed to ${renamedFile.path}");
            _FileList.add(renamedFile);
          });
        }
*/

        if (_imageFileList.isNotEmpty) {
          for (int i = 0; i < _imageFileList.length; i++) {
            // addObject(contentType, i, "POST", resourceId, keyName);

            final int lastDotIndex = _imageFileList[i].path.lastIndexOf(".");
            final String extension =
                _imageFileList[i].path.substring(lastDotIndex + 1);

            final int lastslashIndex = _imageFileList[i].path.lastIndexOf("/");
            final String fileName =
                _imageFileList[i].path.substring(lastslashIndex + 1);

            addObject("image/jpg", i, "POST", post.id, fileName);
          }
          if (uploadData.isNotEmpty) {
            final imageResponse =
                await KitcodApi.instance.postImageConfig(uploadData);
            if (imageResponse != null) {
              if (imageResponse?.body != null &&
                  imageResponse.body!.isNotEmpty) {
                await uploadImage(imageResponse, post.id!)
                    .then((final _) => next());

/*
                for (int j = 0; j < imageResponse.body!.length; j++) {
                  for (int i = 0; i < _imageFileList.length; i++) {
                    if (_imageFileList[i]
                        .path
                        .contains(imageResponse.body![j]!.keyName!)) {
                      final imageUploadResponse = await KitcodApi.instance
                          .uploadImage(
                              imageResponse.body![j]!.mediaUrl!!,
                              _imageFileList[i],
                              imageResponse.body![j]!.keyName!!,
                              post.id!);
                      if (imageUploadResponse != null) {}
                    }
                  }
                }
*/
              }
            }
          }
        }

        /*Navigator.popUntil(context, (final route) => route.isFirst);
        await Navigator.push(
          context,
          MaterialPageRoute(
            builder: (final context) => NewsFeed(
              headerView: HeaderView(
                backgroundColor: Colors.white.withOpacity(0.1),
                backButton: false,
                header: const Text(
                  "News Feed",
                  style: TextStyle(color: Colors.black),
                ),
                headerAlignment: Alignment.centerLeft,
              ),
            ),
          ),
        ).then((final value) => setState(() {}));*/
      }
    } else if (widget.isEdit) {
      final response = await KitcodApi.instance.editPostOnFeedAws(
          widget.feedPostApi!.id!,
          title,
          contentHTML,
          contentMarkdown,
          communityId,
          postType,
          communityType,
          widgetList,
          endingDate,
          isPoll,
          widget.feedPostApi!);

      if (response != null) {
        Navigator.popUntil(context, (final route) => route.isFirst);
        await Navigator.push(
          context,
          MaterialPageRoute(
            builder: (final context) => NewsFeed(
              headerView: HeaderView(
                backgroundColor: Colors.white.withOpacity(0.1),
                backButton: false,
                header: const Text(
                  "News Feed",
                  style: TextStyle(color: Colors.black),
                ),
                headerAlignment: Alignment.centerLeft,
              ),
            ),
          ),
        ).then((final value) => setState(() {}));
      }
    }
  }

  // -------------------------------- UI FUNCTIONS -------------------------------- //

  SizedBox _topWidget(final BuildContext context) => SizedBox(
        width: MediaQuery.of(context).size.width,
        child: Column(
          crossAxisAlignment: CrossAxisAlignment.start,
          children: [
            if (!widget.isEdit)
              BottomSheet(
                optionsHeading: const Text("Select post type",
                    style: TextStyle(fontSize: 20)),
                postType: widget.postType,
                selectedOption: widget.selectedOption,
                iconColor: widget.iconColor,
                iconBackgroundColor: widget.iconBackgroundColor,
                headingStyle: widget.headingStyle,
                descriptionStyle: widget.descriptionStyle,
              ),
            Padding(
              padding: const EdgeInsets.symmetric(horizontal: 10),
              child: ProfileBottomSheet(
                profileDetails: widget.profileDetails,
                nameStyle: widget.nameStyle,
                userNameStyle: widget.userNameStyle,
                groupTagsStyle: widget.groupTagsStyle,
                postedToString: "posted to ",
                optionsHeading: const Text("Select a group to post",
                    style: TextStyle(fontSize: 20)),
                func: (final parentIdd) {
                  communityId = parentIdd;
                },
              ),
            ),
          ],
        ),
      );

  Container _headingField(final BuildContext context) => Container(
        height: 50,
        width: MediaQuery.of(context).size.width,
        color: Colors.white.withOpacity(0.1),
        margin: const EdgeInsets.symmetric(horizontal: 10),
        child: TextFormField(
          controller: headlineController,
          decoration: const InputDecoration(
              border: InputBorder.none,
              focusedBorder: InputBorder.none,
              enabledBorder: InputBorder.none,
              errorBorder: InputBorder.none,
              disabledBorder: InputBorder.none,
              contentPadding:
                  EdgeInsets.only(left: 15, bottom: 10, top: 10, right: 15),
              hintText: "Headline",
              hintStyle: TextStyle(fontSize: 20)),
          style: const TextStyle(fontSize: 24, fontWeight: FontWeight.bold),
        ),
      );

  Container _imageField(final BuildContext context) => Container(
        height: 150,
        width: MediaQuery.of(context).size.width,
        color: Colors.white.withOpacity(0.1),
        margin: const EdgeInsets.symmetric(horizontal: 10),
        child: ListView.builder(
          scrollDirection: Axis.horizontal,
          itemCount: _imageFileList.length,
          itemBuilder: (final context, final index) => Container(
            margin: const EdgeInsets.all(8),
            child: Stack(
              children: [
                Image.file(io.File(_imageFileList![index].path)),
                Positioned(
                    top: 0,
                    right: 0,
                    child: Container(
                      height: 40,
                      width: 40,
                      decoration: const BoxDecoration(
                        color: Colors.black26,
                        borderRadius: BorderRadius.all(Radius.circular(20)),
                      ),
                      child: IconButton(
                        icon: const Icon(
                          Icons.delete,
                          color: Colors.white,
                        ),
                        onPressed: () {
                          // Remove the image from the list and rebuild the list view
                          setState(() {
                            _imageFileList.removeAt(index);
                          });
                        },
                      ),
                    )),
              ],
            ),
          ),
        ),
      );

  Container _storyField(final BuildContext context) => Container(
        height: widget.selectedOption == PostType.poll
            ? 50
            : MediaQuery.of(context).size.height * 0.34,
        width: MediaQuery.of(context).size.width,
        color: Colors.white.withOpacity(0.1),
        margin: const EdgeInsets.symmetric(horizontal: 10),
        child: Column(
          children: [
            Column(
              mainAxisSize: MainAxisSize.min,
              children: [
                SingleChildScrollView(
                  child: TextFormField(
                    maxLines: widget.selectedOption == PostType.poll ? 1 : 10,
                    controller: storyController,
                    decoration: const InputDecoration(
                      border: InputBorder.none,
                      focusedBorder: InputBorder.none,
                      enabledBorder: InputBorder.none,
                      errorBorder: InputBorder.none,
                      disabledBorder: InputBorder.none,
                      contentPadding: EdgeInsets.only(
                          left: 15, top: 10, bottom: 10, right: 15),
                      hintText: "Write your story...",
                      hintStyle: TextStyle(fontSize: 15),
                    ),
                  ),
                ),
              ],
            ),
          ],
        ),
      );

  SizedBox _bottomWidget(final BuildContext context) => SizedBox(
        width: MediaQuery.of(context).size.width,
        child: Column(
          crossAxisAlignment: CrossAxisAlignment.start,
          children: [
            BottomSheet(
              optionsHeading:
                  const Text("More options", style: TextStyle(fontSize: 20)),
              moreOptions: widget.moreOptions,
              iconColor: widget.iconColor,
              iconBackgroundColor: widget.iconBackgroundColor,
              headingStyle: widget.headingStyle,
              descriptionStyle: widget.descriptionStyle,
              context: context,
              imagesSize: _imageFileList.length,
              notifyImageList: updateImageinList,
            ),
            Padding(
              padding: const EdgeInsets.only(
                  bottom: 25, left: 25, right: 25, top: 10),
              child: _isPostLoading
                  ? const Center(
                      child: Padding(
                      padding: EdgeInsets.all(8),
                      child: CircularProgressIndicator(),
                    ))
                  : Button(
                      name: widget.isEdit ? "Update" : "Post",
                      width: MediaQuery.of(context).size.width,
                      onPressed: () {
                        setState(
                          () {
                            _isPostLoading = true;
                            if (widget.selectedOption ==
                                PostType.announcement) {
                              addEditPostToFeed(
                                  headlineController.text,
                                  "<p>${storyController.text}</p><br>",
                                  storyController.text,
                                  communityId!,
                                  widget.selectedOption
                                      .toString()
                                      .toUpperCase()
                                      .split(".")
                                      .last,
                                  "COMMUNITY_CENTER",
                                  null,
                                  null,
                                  false);
                            } else if (widget.selectedOption == PostType.poll) {
                              addEditPostToFeed(
                                  headlineController.text,
                                  "<p>${storyController.text}</p><br>",
                                  storyController.text,
                                  communityId!,
                                  widget.selectedOption
                                      .toString()
                                      .toUpperCase()
                                      .split(".")
                                      .last,
                                  "COMMUNITY_CENTER",
                                  optionslist,
                                  DateTime.now().add(
                                    Duration(
                                        days: widget.currentDaysValue,
                                        hours: widget.currentHoursValue,
                                        minutes: widget.currentMinutesValue),
                                  ),
                                  true);
                            }
                          },
                        );
                      },
                      backgroundColor: Colors.indigo,
                      textStyle: const TextStyle(color: Colors.white),
                    ),
            ),
          ],
        ),
      );

  Padding _addPollOptions(final BuildContext context) => Padding(
        padding: const EdgeInsets.symmetric(horizontal: 20, vertical: 10),
        child: SizedBox(
          height: MediaQuery.of(context).size.height * 0.24,
          child: ListView.builder(
            shrinkWrap: true,
            itemBuilder: (final context, final index) {
              final Widget widget = list.elementAt(index);
              return widget;
            },
            itemCount: list.length,
          ),
        ),
      );

  Padding _pollOption(
          final BuildContext context, final TextEditingController controller) =>
      Padding(
        padding: const EdgeInsets.all(5),
        child: SizedBox(
          height: 40,
          child: Row(
            children: [
              Flexible(
                child: TextField(
                  controller: controller,
                  decoration: InputDecoration(
                      focusedBorder: const OutlineInputBorder(
                          borderSide: BorderSide(color: Colors.grey),
                          borderRadius: BorderRadius.all(Radius.circular(20))),
                      enabledBorder: const OutlineInputBorder(
                          borderSide: BorderSide(color: Colors.grey),
                          borderRadius: BorderRadius.all(Radius.circular(20))),
                      suffixIcon: IconButton(
                        onPressed: controller.clear,
                        icon: const Icon(Icons.clear),
                      ),
                      // ignore: use_named_constants
                      contentPadding: const EdgeInsets.only(left: 10),
                      hintText: "Choice ${list.length + 1}"),
                ),
              ),
              const SizedBox(width: 10),
              SizedBox(
                height: 35,
                width: 35,
                child: ElevatedButton(
                  onPressed: () {
                    pollChoice();
                    setState(() {});
                  },
                  style: ElevatedButton.styleFrom(
                    shape: const CircleBorder(),
                    primary: Colors.blue,
                    onPrimary: Colors.red,
                    padding: EdgeInsets.zero,
                  ),
                  child: const Icon(Icons.add, color: Colors.white),
                ),
              ),
            ],
          ),
        ),
      );

  SizedBox _remainingDuration(final BuildContext context) => SizedBox(
        child: TextButton(
          onPressed: () {
            showDialog(
              context: context,
              builder: (final _) => AlertDialog(
                content: StatefulBuilder(
                  builder: (final context, final setStateDialog) => Row(
                    mainAxisAlignment: MainAxisAlignment.center,
                    children: [
                      Flexible(
                        child: Column(
                          mainAxisSize: MainAxisSize.min,
                          children: [
                            const Center(child: Text("Days")),
                            NumberPicker(
                              value: widget.currentDaysValue,
                              minValue: 0,
                              maxValue: 100,
                              onChanged: (final value) => setState(() =>
                                  setStateDialog(
                                      () => widget.currentDaysValue = value)),
                            ),
                          ],
                        ),
                      ),
                      Flexible(
                        child: Column(
                          mainAxisSize: MainAxisSize.min,
                          children: [
                            const Center(child: Text("Hours")),
                            NumberPicker(
                              value: widget.currentHoursValue,
                              minValue: 0,
                              maxValue: 24,
                              onChanged: (final value) => setState(() =>
                                  setStateDialog(
                                      () => widget.currentHoursValue = value)),
                            ),
                          ],
                        ),
                      ),
                      Flexible(
                        child: Column(
                          mainAxisSize: MainAxisSize.min,
                          children: [
                            const Center(child: Text("Minutes")),
                            NumberPicker(
                              value: widget.currentMinutesValue,
                              minValue: 0,
                              maxValue: 60,
                              onChanged: (final value) => setState(() =>
                                  setStateDialog(() =>
                                      widget.currentMinutesValue = value)),
                            ),
                          ],
                        ),
                      )
                    ],
                  ),
                ),
              ),
            );
          },
          child: Align(
            alignment: Alignment.centerLeft,
            child: Container(
              margin: const EdgeInsets.only(left: 20),
              height: 40,
              width: 260,
              child: DecoratedBox(
                decoration: BoxDecoration(
                  border: Border.all(
                    color: Colors.black87,
                  ),
                  borderRadius: BorderRadius.circular(10),
                ),
                child: Center(
                  child: Row(
                    children: [
                      const SizedBox(width: 5),
                      const Icon(Icons.timer_sharp, color: Colors.black),
                      const SizedBox(width: 5),
                      Text(
                        "Expires in ${widget.currentDaysValue} Days, ${widget.currentHoursValue} Hours, ${widget.currentMinutesValue} Minutes",
                        style:
                            const TextStyle(fontSize: 12, color: Colors.black),
                      ),
                    ],
                  ),
                ),
              ),
            ),
          ),
        ),
      );

  void updateImageinList(
      // ignore: avoid_positional_boolean_parameters
      final List<CroppedFile>? imageList) {
    setState(() {
      _imageFileList.add(imageList![0]);
    });
  }

// -------------------------------- BUILD FUNCTION -------------------------------- //

  @override
  Widget build(final BuildContext context) => Scaffold(
        appBar: widget.headerView,
        body: SingleChildScrollView(
          child: Column(
            children: [
              _topWidget(context),
              _headingField(context),
              if (widget.selectedOption == PostType.announcement)
                _storyField(context),
              if (widget.selectedOption == PostType.poll)
                _addPollOptions(context),
              if (widget.selectedOption == PostType.poll)
                _remainingDuration(context),
              if (_isUploading) _buildProgressDialog(),
              if (_imageFileList != null)
                if (_imageFileList.isNotEmpty) _imageField(context),
              _bottomWidget(context),
            ],
          ),
        ),
      );

  Future _showUploadProgressDialog() async => showDialog(
        context: context,
        builder: (final context) => AlertDialog(
          content: Column(
            children: <Widget>[
              LinearProgressIndicator(value: _progress),
              const SizedBox(height: 10),
              Text("Uploading $_currentIndex of ${_imageFileList.length}"),
            ],
          ),
        ),
      );

  Future<void> uploadImage(
      final ImageUploadAPIModel imageResponse, final String postId) async {
    try {
      final Dio dio = Dio();
      for (int j = 0; j < imageResponse.body!.length; j++) {
        for (int i = 0; i < _imageFileList.length; i++) {
         /* final url = Uri.parse(imageResponse.body![j]!.mediaUrl!!);
          final displayRank = imageResponse.body![j]!.displayRank;
          final file = io.File(_imageFileList[i].path);
          final request = http.MultipartRequest("PUT", url);
          request.headers["x-amz-tagging"] =
              "resourceType=POST&resourceId=$postId&displayRank=$displayRank&type=PostCoverPhoto";
          request.headers["Content-Type"] = "image/jpg";
          final response =  await http.put(
            url,
            headers: {
              "x-amz-tagging":
                  "resourceType=POST&resourceId=$postId&displayRank=$displayRank&type=PostCoverPhoto",
              "Content-Type": "image/jpg",
              "Content-Length": io.File(file.path).lengthSync().toString(),
              "Connection": "keep-alive",
            },
            body: file.readAsBytesSync(),
          );
          if (response.statusCode == 200) {
          } else {}*/


          if (_imageFileList[i]
              .path
              .contains(imageResponse.body![j]!.keyName!)) {
            setState(() {
              _isUploading = true;
            });
            final formData = FormData.fromMap({
              "file": await MultipartFile.fromFile(_imageFileList[i].path,
                  filename: imageResponse.body![j]!.keyName),
            });

            final file = io.File(_imageFileList[i].path);
            final fileBytes = file.readAsBytesSync();

            final displayRank = imageResponse.body![j]!.displayRank;
            final response = await dio.put(imageResponse.body![j]!.mediaUrl!,
                data: file.openRead(),
                options: Options(
                  headers: {
                    "Content-Type": "image/jpg",
                    "x-amz-tagging":
                        "resourceType=POST&resourceId=$postId&displayRank=$displayRank&type=CommunityPic",
                    "Accept": "*/*",
                    "Content-Length": io.File(file.path).lengthSync().toString(),
                    "Connection": "keep-alive",
                    "User-Agent": "ClinicPlush"
                  },
                ), onSendProgress: (final sent, final total) {
              setState(() {
                _progress = sent / total;
                _currentIndex = i + 1;
              });
            });

            if (response.statusCode == 200) {
              Logger.info("Upload success");
            } else {
              Logger.error("Upload failed");
            }
            setState(() {
              _isUploading = false;
            });

/*          final imageUploadResponse = await KitcodApi.instance.uploadImage(
              imageResponse.body![j]!.mediaUrl!!,
              _imageFileList[i],
              imageResponse.body![j]!.keyName!!,
              postId);*/

          }

        }
      }
      next();
    } catch (e) {
      Logger.error(e.toString());
    }
  }

  void next() {
    // do something
    Navigator.popUntil(context, (final route) => route.isFirst);
    Navigator.push(
      context,
      MaterialPageRoute(
        builder: (final context) => NewsFeed(
          headerView: HeaderView(
            backgroundColor: Colors.white.withOpacity(0.1),
            backButton: false,
            header: const Text(
              "News Feed",
              style: TextStyle(color: Colors.black),
            ),
            headerAlignment: Alignment.centerLeft,
          ),
        ),
      ),
    ).then((final value) => setState(() {}));
  }

  Widget _buildProgressDialog() => AlertDialog(
        content: Column(
          children: <Widget>[
            LinearProgressIndicator(value: _progress),
            const SizedBox(height: 10),
            Text("Uploading $_currentIndex of ${_imageFileList.length}"),
          ],
        ),
      );
}
